﻿using System;
using System.Drawing;
using System.IO;
using com.epson.bank.driver;

namespace TM_S9000Sample
{
    class CImageResult
    {
        int m_nTransactionNumber;
        Bitmap m_cImage;
        Stream m_cData;
        int m_nImageSize;
        ImageType m_eGradation;
        ScanSide m_eFace;
        Format m_eFormat;

        public CImageResult()
        {
            m_nTransactionNumber = 0;
            m_cData = null;
            m_cImage = null;
            m_nImageSize = 0;
            m_eGradation = 0;
            m_eFace = 0;
            m_eFormat = 0;
        }

        public void SetTransactionNumber(int nTransactionNumber)
        {
            m_nTransactionNumber = nTransactionNumber;
        }

        public int GetTransactionNumber()
        {
            return m_nTransactionNumber;
        }

        public void SetBitmapImage(Bitmap cImage)
        {
            m_cImage = cImage;
        }

        public Bitmap GetBitmapImage()
        {
            return m_cImage;
        }

        public void SetImageData(Stream cData)
        {
            m_cData = cData;
        }

        public Stream GetImageData()
        {
            return m_cData;
        }

        public void SetImageSize(int nImageSize)
        {
            m_nImageSize = nImageSize;
        }

        public int GetImageSize()
        {
            return m_nImageSize;
        }

        public void SetGradation(ImageType eGradetion)
        {
            m_eGradation = eGradetion;
        }

        public ImageType GetGradation()
        {
            return m_eGradation;
        }

        public void SetFace(ScanSide eFace)
        {
            m_eFace = eFace;
        }

        public ScanSide GetFace()
        {
            return m_eFace;
        }

        public void SetFormat(Format eFormat)
        {
            m_eFormat = eFormat;
        }

        public Format GetFormat()
        {
            return m_eFormat;
        }
        public void FreeImage()
        {
            if (m_cData != null && m_cImage != null)
            {
                m_cData.Dispose();
                m_cImage.Dispose();
                m_nImageSize = 0;
                m_nTransactionNumber = 0;
            }
        }
    }
}
