﻿using System;
using com.epson.bank.driver;

namespace TM_S9000Sample
{
    class COptionParam
    {
        bool m_bOnePiece;
        WaterfallMode m_eWaterfall;
        MfActivateMode m_eActivation;
        MfEject m_eConfirmationEject;
        MfProcessContinue m_eConfirmationCancel;

        MfErrorSelect m_ePaperMisInsertionDetect;
        MfEject m_ePaperMisInsertionEject;
        MfCancel m_ePaperMisInsertionCancel;
        MfErrorSelect m_eNoiseDetect;
        MfEject m_eNoiseEject;
        MfCancel m_eNoiseCancel;
        MfErrorSelect m_eDoubleFeedDetect;
        MfEject m_eDoubleFeedEject;
        MfCancel m_eDoubleFeedCancel;
        MfErrorSelect m_eBaddataDetect;
        MfEject m_eBaddataEject;
        MfCancel m_eBaddataCancel;
        MfErrorSelect m_eNodataDetect;
        MfEject m_eNodataEject;
        MfCancel m_eNodataCancel;
        MfEndorsePrintMode m_eEndorsePrintMode;
        MfCancel m_ePrnDataUnreceiveCancel;

        public COptionParam()
        {
            m_bOnePiece                 = false;
            m_eWaterfall                = WaterfallMode.WATERFALL_MODE_DISABLE;
            m_eActivation               = MfActivateMode.MF_ACTIVATE_MODE_HIGH_SPEED;
            m_eConfirmationEject        = MfEject.MF_EJECT_MAIN_POCKET;
            m_eConfirmationCancel       = MfProcessContinue.MF_PROCESS_CONTINUE_OVERLAP;

            m_ePaperMisInsertionDetect  = MfErrorSelect.MF_ERROR_SELECT_DETECT;
            m_ePaperMisInsertionEject   = MfEject.MF_EJECT_MAIN_POCKET;
            m_ePaperMisInsertionCancel  = MfCancel.MF_CANCEL_DISABLE;
            m_eNoiseDetect              = MfErrorSelect.MF_ERROR_SELECT_DETECT;
            m_eNoiseEject               = MfEject.MF_EJECT_MAIN_POCKET;
            m_eNoiseCancel              = MfCancel.MF_CANCEL_DISABLE;
            m_eDoubleFeedDetect         = MfErrorSelect.MF_ERROR_SELECT_DETECT;
            m_eDoubleFeedEject          = MfEject.MF_EJECT_MAIN_POCKET;
            m_eDoubleFeedCancel         = MfCancel.MF_CANCEL_DISABLE;
            m_eBaddataDetect            = MfErrorSelect.MF_ERROR_SELECT_DETECT;
            m_eBaddataEject             = MfEject.MF_EJECT_MAIN_POCKET;
            m_eBaddataCancel            = MfCancel.MF_CANCEL_DISABLE;
            m_eNodataDetect             = MfErrorSelect.MF_ERROR_SELECT_DETECT;
            m_eNodataEject              = MfEject.MF_EJECT_MAIN_POCKET;
            m_eNodataCancel             = MfCancel.MF_CANCEL_DISABLE;
            m_eEndorsePrintMode         = MfEndorsePrintMode.MF_ENDORSEPRINT_MODE_HIGHSPEED;
            m_ePrnDataUnreceiveCancel   = MfCancel.MF_CANCEL_ENABLE;
        }

        public void SetConfirmationType(bool bOnePiece)
        {
            m_bOnePiece = bOnePiece;
        }

        public bool GetConfirmationType()
        {
            return m_bOnePiece;
        }

        public void SetWaterfall(WaterfallMode eWaterfall)
        {
            m_eWaterfall = eWaterfall;
        }

        public WaterfallMode GetWaterfall()
        {
            return m_eWaterfall;
        }

        public void SetActivation(MfActivateMode eActivation)
        {
            m_eActivation = eActivation;
        }

        public MfActivateMode GetActivation()
        {
            return m_eActivation;
        }

        public void SetConfirmationEject(MfEject eConfirmationEject)
        {
            m_eConfirmationEject = eConfirmationEject;
        }

        public MfEject GetConfirmationEject()
        {
            return m_eConfirmationEject;
        }

        public void SetConfirmationCancel(MfProcessContinue eConfirmationCancel)
        {
            m_eConfirmationCancel = eConfirmationCancel;
        }

        public MfProcessContinue GetConfirmationCancel()
        {
            return m_eConfirmationCancel;
        }

        public void SetPaperMisInsertionDetect(MfErrorSelect ePaperMisInsertionDetect)
        {
            m_ePaperMisInsertionDetect = ePaperMisInsertionDetect;
        }

        public MfErrorSelect GetPaperMisInsertionDetect()
        {
            return m_ePaperMisInsertionDetect;
        }

        public void SetPaperMisInsertionEject(MfEject ePaperMisInsertionEject)
        {
            m_ePaperMisInsertionEject = ePaperMisInsertionEject;
        }

        public MfEject GetPaperMisInsertionEject()
        {
            return m_ePaperMisInsertionEject;
        }

        public void SetPaperMisInsertionCancel(MfCancel ePaperMisInsertionCancel)
        {
            m_ePaperMisInsertionCancel = ePaperMisInsertionCancel;
        }

        public MfCancel GetPaperMisInsertionCancel()
        {
            return m_ePaperMisInsertionCancel;
        }

        public void SetNoiseDetect(MfErrorSelect eNoiseDetect)
        {
            m_eNoiseDetect = eNoiseDetect;
        }

        public MfErrorSelect GetNoiseDetect()
        {
            return m_eNoiseDetect;
        }

        public void SetNoiseEject(MfEject eNoiseEject)
        {
            m_eNoiseEject = eNoiseEject;
        }

        public MfEject GetNoiseEject()
        {
            return m_eNoiseEject;
        }

        public void SetNoiseCancel(MfCancel eNoiseCancel)
        {
            m_eNoiseCancel = eNoiseCancel;
        }

        public MfCancel GetNoiseCancel()
        {
            return m_eNoiseCancel;
        }

        public void SetDoubleFeedDetect(MfErrorSelect eDoubleFeedDetect)
        {
            m_eDoubleFeedDetect = eDoubleFeedDetect;
        }

        public MfErrorSelect GetDoubleFeedDetect()
        {
            return m_eDoubleFeedDetect;
        }

        public void SetDoubleFeedEject(MfEject eDoubleFeedEject)
        {
            m_eDoubleFeedEject = eDoubleFeedEject;
        }

        public MfEject GetDoubleFeedEject()
        {
            return m_eDoubleFeedEject;
        }

        public void SetDoubleFeedCancel(MfCancel eDoubleFeedCancel)
        {
            m_eDoubleFeedCancel = eDoubleFeedCancel;
        }

        public MfCancel GetDoubleFeedCancel()
        {
            return m_eDoubleFeedCancel;
        }

        public void SetBaddataDetect(MfErrorSelect eBaddataDetect)
        {
            m_eBaddataDetect = eBaddataDetect;
        }

        public MfErrorSelect GetBaddataDetect()
        {
            return m_eBaddataDetect;
        }

        public void SetBaddataEject(MfEject eBaddataEject)
        {
            m_eBaddataEject = eBaddataEject;
        }

        public MfEject GetBaddataEject()
        {
            return m_eBaddataEject;
        }

        public void SetBaddataCancel(MfCancel eBaddataCancel)
        {
            m_eBaddataCancel = eBaddataCancel;
        }

        public MfCancel GetBaddataCancel()
        {
            return m_eBaddataCancel;
        }

        public void SetNodataDetect(MfErrorSelect eNodataDetect)
        {
            m_eNodataDetect = eNodataDetect;
        }

        public MfErrorSelect GetNodataDetect()
        {
            return m_eNodataDetect;
        }

        public void SetNodataEject(MfEject eNodataEject)
        {
            m_eNodataEject = eNodataEject;
        }

        public MfEject GetNodataEject()
        {
            return m_eNodataEject;
        }

        public void SetNodataCancel(MfCancel eNodataCancel)
        {
            m_eNodataCancel = eNodataCancel;
        }

        public MfCancel GetNodataCancel()
        {
            return m_eNodataCancel;
        }

        public void SetEndorsePrintMode(MfEndorsePrintMode eEndorsePrintMode)
        {
            m_eEndorsePrintMode = eEndorsePrintMode;
        }

        public MfEndorsePrintMode GetEndorsePrintMode()
        {
            return m_eEndorsePrintMode;
        }

        public void SetPrnDataUnreceiveCancel(MfCancel ePrnDataUnreceiveCancel)
        {
            m_ePrnDataUnreceiveCancel = ePrnDataUnreceiveCancel;
        }

        public MfCancel GetPrnDataUnreceiveCancel()
        {
            return m_ePrnDataUnreceiveCancel;
        }
    }
}
