#if !defined(SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81)
#define SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81

#pragma once

// Step 1
#include "Scan.h"
#include "Micr.h"
#include "Option.h"

typedef int(__stdcall * PROCESS_ERROR_BACK_FUNC)(short);

// Step 2
#include "ScanParam.h"
#include "Image_1.h"

typedef int(__stdcall * COMPLATE_BACK_FUNC)(int);
typedef int(__stdcall * MICR_IMAGE_BACK_FUNC)(void);

#define EXEC_SCAN_CHECK	0
#define EXEC_SCAN_CARD	1

// Step 3
#include "MicrParam.h"

class CApp
{
private:
	// Step 1
	CProperty_1								m_CCProperty;
	CScan									m_CCScan;
	CMicr									m_CCMicr;
	COption									m_CCOption;
	PROCESS_ERROR_BACK_FUNC					m_pFuncProcessErrorCB;

	DLL_BiOpenMonPrinter					BiOpenMonPrinter;
	DLL_BiCloseMonPrinter					BiCloseMonPrinter;
	DLL_BiSCNMICRSetStatusBackFunction		BiSCNMICRSetStatusBackFunction;
	DLL_BiSCNMICRCancelStatusBack			BiSCNMICRCancelStatusBack;
	DLL_BiCancelError						BiCancelError;
	DLL_BiGetStatus							BiGetStatus;

	// Step 2
	CImage_1								m_CCImage;
	BYTE									m_byExecType;
	MICR_IMAGE_BACK_FUNC					m_pFuncImageCB;

	// Step 3
	MICR_IMAGE_BACK_FUNC					m_pFuncMicrCB;

public:
	// Step 1
	CApp(void);
	virtual ~CApp(void);

	int		InitDevice(void);
	int		ExitDevice(void);
	int		CancelError(void);
	int		CancelScan(void);
	int		ScanCheck(void);
	int		GetDeviceStatus(LPDWORD lpStatus);
	void	SetProcessErrorCallback(PROCESS_ERROR_BACK_FUNC pProcessErrorCB);

	// Step 2
	void	SetImageCallback(MICR_IMAGE_BACK_FUNC pImageCB);
	void	SetScanParam(CScanParam* pCCScanParam);
	void	GetScanParam(CScanParam* pCCScanParam);
	int		GetScanImage(CImageResult* pCCImageResult);
	int		ScanCard(void);

	// Step 3
	void	SetMicrCallback(MICR_IMAGE_BACK_FUNC pMicrCB);
	void	SetMicrParam(CMicrParam* pCCMicrParam);
	void	GetMicrParam(CMicrParam* pCCMicrParam);
	int		GetMicr(CMicrResult* pCCMicrResult);
	int		CleaningMicr(void);

private:
	// Step 1
	void		GetAPIProcAddress(void);
	static int	CALLBACK cbScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);
	int			ScanStatus(DWORD dwTransactionNumber, WORD wMainStatus, WORD wSubStatus, LPSTR pPortName);
};

#endif  /* !defined(SAMPLE_ADD27880_C955_40d2_9502_3A8148E05B81) */
