#include "stdafx.h"
#include "Option.h"

COption::COption(void)
{
	m_pCProperty = NULL;
}

COption::~COption(void)
{
}

int COption::Init(CProperty_1* pCCProperty)
{
	int nResult = SUCCESS;

	m_pCProperty = pCCProperty;

	GetAPIProcAddress();

	return nResult;
}

// Set MF_PROCESS01 structure
int COption::SetProcessSetting(void)
{
	int nResult = SUCCESS;

	m_pCProperty->GetMfProcess()->iSize				= sizeof(MF_PROCESS01);
	m_pCProperty->GetMfProcess()->iVersion			= MF_PROCESS_VERSION01;

	nResult = BiSCNMICRFunctionContinuously(m_pCProperty->GetHandle(), m_pCProperty->GetMfProcess(), MF_GET_PROCESS_DEFAULT);
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	m_pCProperty->GetMfProcess()->bActivationMode = m_pCProperty->GetActivation();

	// Mis-Insertion error
	m_pCProperty->GetMfProcess()->bPaperMisInsertionErrorSelect = m_pCProperty->GetPaperMisInsertionDetect();
	if( m_pCProperty->GetPaperMisInsertionDetect() == MF_ERROR_SELECT_DETECT )
	{
		m_pCProperty->GetMfProcess()->bPaperMisInsertionCancel		= m_pCProperty->GetPaperMisInsertionCancel();
		m_pCProperty->GetMfProcess()->bPaperMisInsertionErrorEject	= m_pCProperty->GetPaperMisInsertionEject();
	}

	// Noise error
	m_pCProperty->GetMfProcess()->bNoiseErrorSelect = m_pCProperty->GetNoiseDetect();
	if( m_pCProperty->GetNoiseDetect() == MF_ERROR_SELECT_DETECT )
	{
		m_pCProperty->GetMfProcess()->bNoiseCancel		= m_pCProperty->GetNoiseCancel();
		m_pCProperty->GetMfProcess()->bNoiseErrorEject	= m_pCProperty->GetNoiseEject();
	}

	// Double feed error
	m_pCProperty->GetMfProcess()->bDoubleFeedErrorSelect = m_pCProperty->GetDoubleFeedDetect();
	if( m_pCProperty->GetDoubleFeedDetect() == MF_ERROR_SELECT_DETECT )
	{
		m_pCProperty->GetMfProcess()->bDoubleFeedCancel		= m_pCProperty->GetDoubleFeedCancel();
		m_pCProperty->GetMfProcess()->bDoubleFeedErrorEject	= m_pCProperty->GetDoubleFeedEject();
	}

	// Bad data in MICR error
	m_pCProperty->GetMfProcess()->bBaddataErrorSelect = m_pCProperty->GetBaddataDetect();
	if( m_pCProperty->GetBaddataDetect() == MF_ERROR_SELECT_DETECT )
	{
		m_pCProperty->GetMfProcess()->bBaddataCancel		= m_pCProperty->GetBaddataCancel();
		m_pCProperty->GetMfProcess()->bBaddataErrorEject	= m_pCProperty->GetBaddataEject();
		m_pCProperty->GetMfProcess()->bBaddataCount			= 0;
	}

	// No data in MICR magnetic waveform error
	m_pCProperty->GetMfProcess()->bNodataErrorSelect = m_pCProperty->GetNodataDetect();
	if( m_pCProperty->GetNodataDetect() == MF_ERROR_SELECT_DETECT )
	{
		m_pCProperty->GetMfProcess()->bNodataCancel			= m_pCProperty->GetNodataCancel();
		m_pCProperty->GetMfProcess()->bNodataErrorEject		= m_pCProperty->GetNodataEject();
	}

	// Set endorsement printing mode
	m_pCProperty->GetMfProcess()->bEndorsePrintMode = m_pCProperty->GetEndorsePrintMode();

	// Print data unreceived error
	m_pCProperty->GetMfProcess()->bPrnDataUnreceiveCancel = m_pCProperty->GetPrnDataUnreceiveCancel();

	nResult = BiSCNMICRFunctionContinuously(m_pCProperty->GetHandle(), m_pCProperty->GetMfProcess(), MF_SET_PROCESS_PARAM);
	
	return nResult;
}

// Set Waterfall Mode
int COption::SetWaterfallMode(void)
{
	int nResult = 0;

	nResult = BiSetWaterfallMode(m_pCProperty->GetHandle(), m_pCProperty->GetWaterfall());

	return nResult;
}

// Perform scanning using confirmation mode
int COption::ConfirmationFunction(void)
{
	int nResult = 0;

	nResult = BiSetBehaviorToScnResult(m_pCProperty->GetHandle(), m_pCProperty->GetConfirmationEject(),
														MF_STAMP_DISABLE, m_pCProperty->GetConfirmationCancel());

	return nResult;
}

// Get functions of the API
void COption::GetAPIProcAddress(void)
{
	HINSTANCE hLibrary = m_pCProperty->GetLibrary();

	BiSCNMICRFunctionContinuously	= (DLL_BiSCNMICRFunctionContinuously)	GetProcAddress(hLibrary, "BiSCNMICRFunctionContinuously");
	BiSetWaterfallMode				= (DLL_BiSetWaterfallMode)				GetProcAddress(hLibrary, "BiSetWaterfallMode");
	BiSetBehaviorToScnResult		= (DLL_BiSetBehaviorToScnResult)		GetProcAddress(hLibrary, "BiSetBehaviorToScnResult");
}
