
#define STR_NAME_MUTEX	_T("Mutex EPSON TM-S9000 Sample Program Step6")

typedef struct tagConfigData
{
	// Step 2
	int	nRadio_ScanningMedia;
	int	nRadio_ImageChannel;
	int	nRadio_RGBColorDepth;
	int	nRadio_IRColorDepth;
	int	nCheck_Scan_SaveFile;
	int	nCombo_Resolution;

	// Step 3
	int	nRadio_MICRFont;
	int	nCheck_MICR_MICRParsing;
	int	nCheck_MICR_ClearSpace;
	int	nCheck_MICR_SaveFile;

	// Step 6
	int nCheck_Buzzer_Success;
	int nCheck_Buzzer_DoubleFeed;
	int nCheck_Buzzer_Error;

	int nRadio_OcrABFont;
	int nCheck_OcrAB_OcrAB;
	int nCheck_OcrAB_SaveFile;

	tagConfigData(void)
	{
		// Step 2
		nRadio_ScanningMedia	= VAL_CONFIGDLG_RADIO_SM_CHECKPAPER;
		nRadio_ImageChannel		= VAL_CONFIGDLG_RADIO_IC_RGB;
		nRadio_RGBColorDepth	= VAL_CONFIGDLG_RADIO_RGBCD_COLOR;
		nRadio_IRColorDepth		= VAL_CONFIGDLG_RADIO_IRCD_GRAY;
		nCheck_Scan_SaveFile	= VAL_CONFIGDLG_CHECK_SC_SAVEFILE_ON;
		nCombo_Resolution		= VAL_CONFIGDLG_COMBO_RE_200200;

		// Step 3
		nRadio_MICRFont			= VAL_CONFIGDLG_RADIO_MF_E13B;
		nCheck_MICR_MICRParsing	= VAL_CONFIGDLG_CHECK_MI_MICRPARSING_OFF;
		nCheck_MICR_ClearSpace	= VAL_CONFIGDLG_CHECK_MI_CLEARSPACE_OFF;
		nCheck_MICR_SaveFile	= VAL_CONFIGDLG_CHECK_MI_SAVEFILE_OFF;

		// Step 6
		nCheck_Buzzer_Success		= VAL_CONFIGDLG_CHECK_BU_SUCCESS_OFF;
		nCheck_Buzzer_DoubleFeed	= VAL_CONFIGDLG_CHECK_BU_DOUBLEFEED_OFF;
		nCheck_Buzzer_Error			= VAL_CONFIGDLG_CHECK_BU_ERROR_OFF;

		nRadio_OcrABFont			= VAL_CONFIGDLG_RADIO_OF_OCRA;
		nCheck_OcrAB_OcrAB			= VAL_CONFIGDLG_CHECK_OC_OCRAB_OFF;
		nCheck_OcrAB_SaveFile		= VAL_CONFIGDLG_CHECK_OC_SAVEFILE_OFF;
	}

	void Copy( const tagConfigData & sData )
	{
		// Step 2
		nRadio_ScanningMedia	= sData.nRadio_ScanningMedia;
		nRadio_ImageChannel		= sData.nRadio_ImageChannel;
		nRadio_RGBColorDepth	= sData.nRadio_RGBColorDepth;
		nRadio_IRColorDepth		= sData.nRadio_IRColorDepth;
		nCheck_Scan_SaveFile	= sData.nCheck_Scan_SaveFile;
		nCombo_Resolution		= sData.nCombo_Resolution;

		// Step 3
		nRadio_MICRFont			= sData.nRadio_MICRFont;
		nCheck_MICR_MICRParsing	= sData.nCheck_MICR_MICRParsing;
		nCheck_MICR_ClearSpace	= sData.nCheck_MICR_ClearSpace;
		nCheck_MICR_SaveFile	= sData.nCheck_MICR_SaveFile;

		// Step 6
		nCheck_Buzzer_Success		= sData.nCheck_Buzzer_Success;
		nCheck_Buzzer_DoubleFeed	= sData.nCheck_Buzzer_DoubleFeed;
		nCheck_Buzzer_Error			= sData.nCheck_Buzzer_Error;

		nRadio_OcrABFont			= sData.nRadio_OcrABFont;
		nCheck_OcrAB_OcrAB			= sData.nCheck_OcrAB_OcrAB;
		nCheck_OcrAB_SaveFile		= sData.nCheck_OcrAB_SaveFile;
	}
} CONFIGDATA, *LPCONFIGDATA;
