#include "stdafx.h"
#include "Barcode.h"

CBarcode::CBarcode(void)
{
	m_pCProperty = NULL;
}

CBarcode::~CBarcode(void)
{
}

int CBarcode::Init(CProperty_1* pCCProperty)
{
	int nResult = SUCCESS;

	m_pCProperty = pCCProperty;

	GetAPIProcAddress();

	return nResult;
}

// Set MF_BARCODE structure
int CBarcode::SetBarcodeSetting(void)
{
	int nResult = SUCCESS;

	// Settings for front side
	nResult = BiSCNMICRFunctionContinuously(m_pCProperty->GetHandle(), m_pCProperty->GetMfBarcodeFront(), MF_GET_BARCODE_FRONT_DEFAULT);
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	m_pCProperty->GetMfBarcodeFront()->iSize	= sizeof(MF_BARCODE);
	m_pCProperty->GetMfBarcodeFront()->iVersion	= MF_BARCODE_VERSION;
	// Specify barcode symbols to be decoded
	m_pCProperty->GetMfBarcodeFront()->stInfo[0].dwSymbolMask = MF_BARCODE_SYMBOL_CODE128;

	// Barcode detection error
	m_pCProperty->GetMfBarcodeFront()->bErrorSelect = m_pCProperty->GetBarcodeDetect();
	if( m_pCProperty->GetBarcodeDetect() == MF_ERROR_SELECT_DETECT )
	{
		m_pCProperty->GetMfBarcodeFront()->bErrorEject	= m_pCProperty->GetBarcodeEject();
		m_pCProperty->GetMfBarcodeFront()->bCancel		= m_pCProperty->GetBarcodeCancel();
	}

	nResult = BiSCNMICRFunctionContinuously(m_pCProperty->GetHandle(), m_pCProperty->GetMfBarcodeFront(), MF_SET_BARCODE_FRONT_PARAM);
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	return nResult;
}

// Obtain barcode data
int CBarcode::GetBarcode(CBarcodeResult* pCCBarcodeResult)
{
	int nResult = 0;
	int nCount	= 0;
	CString strBarcodeData;
	BARCODE_DATA *pBarcodeData = NULL;

	if(pCCBarcodeResult == NULL)
	{
		return -1;
	}

	nResult = BiSCNSelectScanFace(m_pCProperty->GetHandle(), MF_SCAN_FACE_FRONT);
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	nResult = BiGetBarcodeData(m_pCProperty->GetHandle(), m_pCProperty->GetTransactionNumber(), m_pCProperty->GetMfBarcodeFront());
	if(nResult != SUCCESS)
	{
		return nResult;
	}

	if(m_pCProperty->GetMfBarcodeFront()->lpData != NULL)
	{
		pBarcodeData = (BARCODE_DATA*)m_pCProperty->GetMfBarcodeFront()->lpData;
		for(nCount = 0; nCount < m_pCProperty->GetMfBarcodeFront()->bDataCount; nCount++)
		{
			strBarcodeData.Append((LPSTR)pBarcodeData[nCount].pData, pBarcodeData[nCount].dwDataSize);
			strBarcodeData.Append(" ");
			::GlobalFree(pBarcodeData[nCount].pData);
		}

		::GlobalFree(m_pCProperty->GetMfBarcodeFront()->lpData);
		m_pCProperty->GetMfBarcodeFront()->lpData = NULL;
	}

	pCCBarcodeResult->SetBarcodeData(strBarcodeData);

	return nResult;
}

// Get functions of the API
void CBarcode::GetAPIProcAddress(void)
{
	HINSTANCE hLibrary = m_pCProperty->GetLibrary();

	BiSCNMICRFunctionContinuously	= (DLL_BiSCNMICRFunctionContinuously)	GetProcAddress(hLibrary, "BiSCNMICRFunctionContinuously");
	BiGetBarcodeData 				= (DLL_BiGetBarcodeData)				GetProcAddress(hLibrary, "BiGetBarcodeData");
	BiSCNSelectScanFace				= (DLL_BiSCNSelectScanFace)				GetProcAddress(hLibrary, "BiSCNSelectScanFace");
}

