VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Endorse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private m_pCProperty As Property_1
Private byLogoImage() As Byte

Private Sub Class_Initialize()

    If (m_pCProperty Is Nothing) Then
        Set m_pCProperty = New Property_1
    End If
    
End Sub

Public Sub SetProperty(ByRef pCProperty As Property_1)

    Set m_pCProperty = pCProperty

End Sub
    
Public Function LoadEndorseFile() As Long

    Dim lResult As Long

    '// Loading printing region setting file for template printing
    Dim lLoadNum As Long
    Dim strPath As String
    Dim strDir As String
    
    strDir = CurDir$()
    
    strPath = strDir & "\" & "FormatSettingStep4.ini"

    '// Set print information for physical endorsement
    lResult = BiSetPrintStation(m_pCProperty.GetHandle(), MF_ST_PHYSICAL_ENDORSEMENT)
    If Not (lResult = SUCCESS) Then
    
        LoadEndorseFile = lResult
        Exit Function
        
    End If
    
    lResult = BiLoadTemplatePrintArea(m_pCProperty.GetHandle(), strPath, lLoadNum)
    If Not (lResult = SUCCESS) Then
    
        LoadEndorseFile = lResult
        Exit Function
    
    End If

    '// Set print information for electronic endorsement
    lResult = BiSetPrintStation(m_pCProperty.GetHandle(), MF_ST_E_ENDORSEMENT)
    If Not (lResult = SUCCESS) Then
    
        LoadEndorseFile = lResult
        Exit Function
        
    End If
    
    lResult = BiLoadTemplatePrintArea(m_pCProperty.GetHandle(), strPath, lLoadNum)
    If Not (lResult = SUCCESS) Then
    
        LoadEndorseFile = lResult
        Exit Function
    
    End If

    '// Loading image file for printing
    Dim hFile As Long
    Dim lImageSize As Long
    Dim lReadSize As Long
    Dim bResule As Boolean
    
    hFile = CreateFile("Logo.bmp", GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
    If (hFile = INVALID_HANDLE_VALUE) Then
    
        LoadEndorseFile = ERR_IMAGE_FILEOPEN
        Exit Function
    
    End If

    lImageSize = GetFileSize(hFile, 0)
    ReDim byLogoImage(lImageSize - 1)
    lResult = ReadFile(hFile, byLogoImage(0), lImageSize, lReadSize, ByVal 0&)
    If (lResult = False) Then
    
        LoadEndorseFile = ERR_IMAGE_FILEREAD
        Exit Function
    
    End If

    LoadEndorseFile = SUCCESS

End Function

Public Function SetEndorseStation() As Long

    Dim lResult As Long

    '// Select print station
    lResult = BiSetPrintStation(m_pCProperty.GetHandle(), m_pCProperty.GetEndorseType())
    
    SetEndorseStation = lResult

End Function

Public Function PhysicalEndorseFunction(ByVal lTransactionNumber As Long) As Long

    Dim lResult As Long
    Dim lImageSize As Long
    Dim sInfo As PRINTAREAINFO
    lResult = SUCCESS

    '// Start buffering of print data for format printing
    lResult = BiTemplatePrint(m_pCProperty.GetHandle(), TEMPLATEPRINT_BUFFERING)
    If Not (lResult = SUCCESS) Then
    
        PhysicalEndorseFunction = lResult
        Exit Function
        
    End If
    
    '// Set image data for printing
    If (m_pCProperty.GetPrintImage()) Then
    
        '/*PhysicalEndorseImage*/
        lResult = BiSetTemplatePrintArea(m_pCProperty.GetHandle(), SELECTPRINTAREA_AREANAME, "PhysicalEndorseImage", sInfo, lTransactionNumber)
        If Not (lResult = SUCCESS) Then
        
            PhysicalEndorseFunction = lResult
            Exit Function
        
        End If

        lImageSize = UBound(byLogoImage) + 1
        lResult = BiSCNPrintMemoryImage(m_pCProperty.GetHandle(), lTransactionNumber, byLogoImage(0), lImageSize)
        If Not (lResult = SUCCESS) Then
        
            PhysicalEndorseFunction = lResult
            Exit Function
        
        End If
        
    End If

    '// set strings for printing
    If (m_pCProperty.GetPrintText()) Then
        
        Dim tDecorate As mf_Decorate
        Call CopyMemory(tDecorate.dwAttribute(1), MF_PRINT_NO_ATTRIBUTE, 4)
        Call CopyMemory(tDecorate.wFont(1), MF_PRINT_SYSTEMFONT, 2)
        Call CopyMemory(tDecorate.szFontName(1), "Arial", 4)
        Call CopyMemory(tDecorate.wFontSize(1), 9, 2)
        
        Dim sTime As SYSTEMTIME
        Dim strTimeString As String

        Dim strPhysicalrString As String
        Dim stSystemTime As SYSTEMTIME
        Dim strMonth(12) As String
        strMonth(0) = ""
        strMonth(1) = "Jan"
        strMonth(2) = "Feb"
        strMonth(3) = "Mar"
        strMonth(4) = "Apr"
        strMonth(5) = "May"
        strMonth(6) = "Jun"
        strMonth(7) = "Jul"
        strMonth(8) = "Aug"
        strMonth(9) = "Sep"
        strMonth(10) = "Oct"
        strMonth(11) = "Nov"
        strMonth(12) = "Dec"

        '/*EndorseText1*/
        lResult = BiSetTemplatePrintArea(m_pCProperty.GetHandle(), SELECTPRINTAREA_AREANAME, "PhysicalEndorseText1", sInfo, lTransactionNumber)
        If Not (lResult = SUCCESS) Then
        
            PhysicalEndorseFunction = lResult
            Exit Function
        
        End If

        
        GetLocalTime stSystemTime

        strPhysicalrString = "  " & strMonth(stSystemTime.nMonth) & _
                                " " & Format$(stSystemTime.nDay, "00") & _
                                " " & Format$(stSystemTime.nYear, "0000") & vbCrLf

        strPhysicalrString = strPhysicalrString & " " & _
                                Format$(stSystemTime.nHour, "00") & ":" & _
                                Format$(stSystemTime.nMinute, "00") & ":" & _
                                Format$(stSystemTime.nSecond, "00") & ":" & _
                                Format$(stSystemTime.nMilliseconds, "0000") & vbCrLf & vbCrLf
        
        strPhysicalrString = strPhysicalrString & "  &>1234567890&<"
        
        lResult = BiSCNPrintText(m_pCProperty.GetHandle(), lTransactionNumber, strPhysicalrString, tDecorate)
        If Not (lResult = SUCCESS) Then
        
            PhysicalEndorseFunction = lResult
            Exit Function
        
        End If

        '/*EndorseText2*/
        lResult = BiSetTemplatePrintArea(m_pCProperty.GetHandle(), SELECTPRINTAREA_AREANAME, "PhysicalEndorseText2", sInfo, lTransactionNumber)
        If Not (lResult = SUCCESS) Then
        
            PhysicalEndorseFunction = lResult
            Exit Function
        
        End If

        strPhysicalrString = "  &>1234567890&<"
        lResult = BiSCNPrintText(m_pCProperty.GetHandle(), lTransactionNumber, strPhysicalrString, tDecorate)
        If Not (lResult = SUCCESS) Then
        
            PhysicalEndorseFunction = lResult
            Exit Function
        
        End If
        
    End If

    '// Print buffered data
    lResult = BiTemplatePrint(m_pCProperty.GetHandle(), TEMPLATEPRINT_EXEC)
    If Not (lResult = SUCCESS) Then
    
        PhysicalEndorseFunction = lResult
        Exit Function
        
    End If

    PhysicalEndorseFunction = lResult

End Function

Public Function ElectronicEndorseFunction() As Long

    Dim lResult As Long
    Dim sInfo As PRINTAREAINFO
    lResult = SUCCESS

    '// Start buffering of print data for format printing
    lResult = BiTemplatePrint(m_pCProperty.GetHandle(), TEMPLATEPRINT_BUFFERING)
    If Not (lResult = SUCCESS) Then
    
        ElectronicEndorseFunction = lResult
        Exit Function
        
    End If
    
    '// Set image data for printing
    If (m_pCProperty.GetPrintImage()) Then
    
        '/*ElectronicEndorseImage*/
        lResult = BiSetTemplatePrintArea(m_pCProperty.GetHandle(), SELECTPRINTAREA_AREANAME, "ElectronicEndorseImage", sInfo, TRANS_NO_SPECIFIED)
        If Not (lResult = SUCCESS) Then
        
            ElectronicEndorseFunction = lResult
            Exit Function
        
        End If

        lResult = BiPrintImage(m_pCProperty.GetHandle(), "Logo.bmp")
        If Not (lResult = SUCCESS) Then
        
            ElectronicEndorseFunction = lResult
            Exit Function
        
        End If
        
    End If

    '// set strings for printing
    If (m_pCProperty.GetPrintText()) Then
        
        Dim tDecorate As mf_Decorate
        Call CopyMemory(tDecorate.dwAttribute(1), MF_PRINT_NO_ATTRIBUTE, 4)
        Call CopyMemory(tDecorate.wFont(1), MF_PRINT_SYSTEMFONT, 2)
        Call CopyMemory(tDecorate.szFontName(1), "Arial", 4)
        Call CopyMemory(tDecorate.wFontSize(1), 9, 2)
        
        Dim sTime As SYSTEMTIME
        Dim strTimeString As String

        Dim strElectronicrString As String
        Dim stSystemTime As SYSTEMTIME
        Dim strMonth(12) As String
        strMonth(0) = "Jan"
        strMonth(1) = "Feb"
        strMonth(2) = "Tue"
        strMonth(3) = "Mar"
        strMonth(4) = "Apr"
        strMonth(5) = "May"
        strMonth(6) = "Jun"
        strMonth(7) = "Jul"
        strMonth(8) = "Aug"
        strMonth(9) = "Sep"
        strMonth(10) = "Oct"
        strMonth(11) = "Nov"
        strMonth(12) = "Dec"

        '/*EndorseText1*/
        lResult = BiSetTemplatePrintArea(m_pCProperty.GetHandle(), SELECTPRINTAREA_AREANAME, "ElectronicEndorseText1", sInfo, TRANS_NO_SPECIFIED)
        If Not (lResult = SUCCESS) Then
        
            ElectronicEndorseFunction = lResult
            Exit Function
        
        End If

        
        GetLocalTime stSystemTime

        strElectronicrString = "  " & strMonth(stSystemTime.nMonth) & _
                                " " & Format$(stSystemTime.nDay, "00") & _
                                " " & Format$(stSystemTime.nYear, "0000") & vbCrLf

        strElectronicrString = strElectronicrString & " " & _
                                Format$(stSystemTime.nHour, "00") & ":" & _
                                Format$(stSystemTime.nMinute, "00") & ":" & _
                                Format$(stSystemTime.nSecond, "00") & ":" & _
                                Format$(stSystemTime.nMilliseconds, "0000") & vbCrLf & vbCrLf
        
        strElectronicrString = strElectronicrString & "  &>1234567890&<"

        lResult = BiPrintTextToVB(m_pCProperty.GetHandle(), strElectronicrString, tDecorate)
        If Not (lResult = SUCCESS) Then
        
            ElectronicEndorseFunction = lResult
            Exit Function
        
        End If

        '/*EndorseText2*/
        lResult = BiSetTemplatePrintArea(m_pCProperty.GetHandle(), SELECTPRINTAREA_AREANAME, "ElectronicEndorseText2", sInfo, TRANS_NO_SPECIFIED)
        If Not (lResult = SUCCESS) Then
        
            ElectronicEndorseFunction = lResult
            Exit Function
        
        End If

        strElectronicrString = "  &>1234567890&<"
        lResult = BiPrintTextToVB(m_pCProperty.GetHandle(), strElectronicrString, tDecorate)
        If Not (lResult = SUCCESS) Then
        
            ElectronicEndorseFunction = lResult
            Exit Function
        
        End If
        
    End If

    '// Print buffered data
    lResult = BiTemplatePrint(m_pCProperty.GetHandle(), TEMPLATEPRINT_EXEC)
    If Not (lResult = SUCCESS) Then
    
        ElectronicEndorseFunction = lResult
        Exit Function
        
    End If

    ElectronicEndorseFunction = lResult

End Function

