VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Image_01"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private m_pCProperty As Property_1

Private Sub Class_Initialize()

    If (m_pCProperty Is Nothing) Then
        Set m_pCProperty = New Property_1
    End If

End Sub

Public Sub SetProperty(ByRef pCProperty As Property_1)

    Set m_pCProperty = pCProperty

End Sub

'// Specify image data format
Public Function SetImageSetting(ByVal byFace As Byte, ByVal byGradation As Integer, ByVal byFormat As Byte) As Long

    Dim lResult As Long
    Dim byColorDepth As Byte
    Dim byColor As Byte
    Dim byExOption As Byte
    
    lResult = SUCCESS
    byColorDepth = EPS_BI_SCN_24BIT
    byColor = EPS_BI_SCN_COLOR
    byExOption = EPS_BI_SCN_MANUAL

    lResult = BiSCNSelectScanFace(m_pCProperty.GetHandle(), byFace)
    If Not (lResult = SUCCESS) Then
    
        SetImageSetting = lResult
        Exit Function
        
    End If

    lResult = BiSCNSelectScanImage(m_pCProperty.GetHandle(), byGradation)
    If Not (lResult = SUCCESS) Then
    
        SetImageSetting = lResult
        Exit Function
        
    End If


    If (byGradation = MF_SCAN_IMAGE_VISIBLE) Then
    
        byColorDepth = m_pCProperty.GetRGBColorDepth()
    
    Else
    
        byColorDepth = m_pCProperty.GetIRColorDepth()
    
    End If

    If (byColorDepth = EPS_BI_SCN_24BIT) Then
    
        byColor = EPS_BI_SCN_COLOR
        byExOption = EPS_BI_SCN_MANUAL
    
    Else
    
        byColor = EPS_BI_SCN_MONOCHROME
        byExOption = EPS_BI_SCN_SHARP
    
    End If

    lResult = BiSCNSetImageQuality(m_pCProperty.GetHandle(), byColorDepth, 0, byColor, byExOption)
    If Not (lResult = SUCCESS) Then
    
        SetImageSetting = lResult
        Exit Function
        
    End If


    lResult = BiSCNSetImageFormat(m_pCProperty.GetHandle(), byFormat)

    SetImageSetting = lResult
    
End Function

'// Get check image
Public Function GetScanImage(ByRef pCCImageResult As ImageResult) As Long

    Dim lResult As Long
    Dim m_objmfScan As MF_SCAN
    Dim lScanData As Long
    Dim lScanSize As Long

    lResult = SUCCESS

    lResult = SetImageSetting(pCCImageResult.GetFace(), pCCImageResult.GetGradation(), pCCImageResult.GetFormat())
    If Not (lResult = SUCCESS) Then
    
        GetScanImage = lResult
        Exit Function
    
    End If

    If (pCCImageResult.GetFace() = MF_SCAN_FACE_FRONT) Then
    
        m_objmfScan = m_pCProperty.GetMfScanFront()
    
    Else
    
        m_objmfScan = m_pCProperty.GetMfScanBack()
    
    End If

    lResult = BiGetScanImage(m_pCProperty.GetHandle(), m_pCProperty.GetTransactionNumber(), m_objmfScan)
    If Not (lResult = SUCCESS) Then
    
        GetScanImage = lResult
        Exit Function
    
    End If
    
    Call CopyMemory(lScanData, m_objmfScan.lpbScanData(1), 4)
    Call CopyMemory(lScanSize, m_objmfScan.dwScanSize(1), 4)

    pCCImageResult.SetTransactionNumber (m_pCProperty.GetTransactionNumber())
    pCCImageResult.SetImageSize (lScanSize)
    pCCImageResult.SetImage (lScanData)

    '// Obtained image data is not stored in this class
    Erase m_objmfScan.dwScanSize
    Erase m_objmfScan.lpbScanData

    GetScanImage = lResult

End Function

'// Get cashier's check image
Public Function GetCashiersCheckImage(ByRef pCCImageResult As ImageResult) As Long

    Dim lResult As Long
    Dim m_objmfScan As MF_SCAN
    Dim lScanData As Long
    Dim lScanSize As Long

    lResult = SUCCESS

    lResult = BiSCNSelectScanFace(m_pCProperty.GetHandle(), pCCImageResult.GetFace())
    If Not (lResult = SUCCESS) Then
    
        GetCashiersCheckImage = lResult
        Exit Function
    
    End If

    lResult = BiSCNSelectScanImage(m_pCProperty.GetHandle(), MF_SCAN_IMAGE_VISIBLE)
    If Not (lResult = SUCCESS) Then
    
        GetCashiersCheckImage = lResult
        Exit Function
    
    End If

    lResult = BiSCNSetImageQuality(m_pCProperty.GetHandle(), EPS_BI_SCN_24BIT, 0, EPS_BI_SCN_COLOR, EPS_BI_SCN_MANUAL)
    If Not (lResult = SUCCESS) Then
    
        GetCashiersCheckImage = lResult
        Exit Function
    
    End If
    
    lResult = BiSCNSetImageFormat(m_pCProperty.GetHandle(), EPS_BI_SCN_BITMAP)
    If Not (lResult = SUCCESS) Then
    
        GetCashiersCheckImage = lResult
        Exit Function
    
    End If

    m_objmfScan = m_pCProperty.GetMfScanFront()
    lResult = BiGetScanImage(m_pCProperty.GetHandle(), m_pCProperty.GetTransactionNumber(), m_objmfScan)
    If Not (lResult = SUCCESS) Then
    
        GetCashiersCheckImage = lResult
        Exit Function
    
    End If

    
    Call CopyMemory(lScanData, m_objmfScan.lpbScanData(1), 4)
    Call CopyMemory(lScanSize, m_objmfScan.dwScanSize(1), 4)

    pCCImageResult.SetTransactionNumber (m_pCProperty.GetTransactionNumber())
    pCCImageResult.SetImageSize (lScanSize)
    pCCImageResult.SetImage (lScanData)

    '// Obtained image is not stored in this class
    Erase m_objmfScan.dwScanSize
    Erase m_objmfScan.lpbScanData

    GetCashiersCheckImage = lResult

End Function

