Attribute VB_Name = "MultiFunction"
'/******************************************************************************/
'/* Copyright (C) SEIKO EPSON CORPORATION 2011. All rights reserved.           */
'/******************************************************************************/
'/*                                                                            */
'/* MultiFunction.h                                                            */
'/*                                                                            */
'/* Definition of the constants and also data type.                            */
'/*                                                                            */
'/* Modification history                                                       */
'/* -------------------------------------------------------------------------- */
'/* 2011-07-12   New                                                           */
'/*                                                                            */
'/******************************************************************************/

'#if !defined(_MULTI_FUNCTION_H)
'Public Const _MULTI_FUNCTION_H


'#if defined(WIN32)

'#elif defined(__GNUC__)

'#End If


'/******************************************************************************/
'/******************************************************************************/
'/* ERROR CODE                                                                 */
'/******************************************************************************/
'/******************************************************************************/
Public Const SUCCESS& = 0                                    '/* Success                                                            */

Public Const ERR_UNKNOWN& = -9999                            '/* Unknown Error                                                      */

Public Const ERR_TYPE& = -10                                 '/* nType error                                                        */
Public Const ERR_OPENED& = -20                               '/* Already opened                                                     */
Public Const ERR_NO_PRINTER& = -30                           '/* There is not printer driver                                        */
Public Const ERR_NO_TARGET& = -40                            '/* Printer out of object                                              */
Public Const ERR_NO_MEMORY& = -50                            '/* No memory                                                          */
Public Const ERR_HANDLE& = -60                               '/* Invalid handle                                                     */
Public Const ERR_TIMEOUT& = -70                              '/* Time out                                                           */
Public Const ERR_ACCESS& = -80                               '/* cannot read/write                                                  */
Public Const ERR_PARAM& = -90                                '/* param error                                                        */
Public Const ERR_NOT_SUPPORT& = -100                         '/* not support                                                        */
Public Const ERR_OFFLINE& = -110                             '/* now offline                                                        */
Public Const ERR_NOT_EPSON& = -120                           '/* not epson printer                                                  */
Public Const ERR_WITHOUT_CB& = -130                          '/* without callback function                                          */
Public Const ERR_BUFFER_OVER_FLOW& = -140                    '/* Read buffer over flow                                              */
Public Const ERR_REGISTRY& = -150                            '/* Registry error                                                     */
Public Const ERR_ENABLE& = -160                              '/* BiOpenMonPrinter() is already called                               */
Public Const ERR_DISK_FULL& = -170                           '/* Capacity of a disk is insufficient                                 */
Public Const ERR_NO_IMAGE& = -180                            '/* No image data                                                      */
Public Const ERR_ENTRY_OVER& = -190                          '/* Registration number-of-cases over                                  */
Public Const ERR_CROPAREAID& = -200                          '/* No specific CropAreaID                                             */
Public Const ERR_EXIST& = -210                               '/* Already the same thing                                             */
Public Const ERR_NOT_FOUND& = -220                           '/* Not found                                                          */
Public Const ERR_IMAGE_FILEOPEN& = -230                      '/* Open failure                                                       */
Public Const ERR_IMAGE_UNKNOWNFORMAT& = -240                 '/* Unknown format                                                     */
Public Const ERR_IMAGE_FAILED& = -250                        '/* Image creation failure                                             */
Public Const ERR_WORKAREA_NO_MEMORY& = -260                  '/* No memory for WORKAREA                                             */
Public Const ERR_WORKAREA_UNKNOWNFORMAT& = -270              '/* Image creation failure because of format injustice                 */
Public Const ERR_WORKAREA_FAILED& = -280                     '/* WORKAREA creation failure                                          */
Public Const ERR_IMAGE_FILEREAD& = -290                      '/* Image file read error                                              */
Public Const ERR_PAPERINSERT_TIMEOUT& = -300                 '/* Image paper insert error of timeout                                */
Public Const ERR_EXEC_FUNCTION& = -310                       '/* Other API is running                                               */
Public Const ERR_EXEC_MICR& = -320                           '/* Now reading MICR                                                   */
Public Const ERR_EXEC_SCAN& = -330                           '/* Now scanning image                                                 */
Public Const ERR_SS_NOT_EXIST& = -340                        '/* Status service not started                                         */
Public Const ERR_SPL_NOT_EXIST& = -350                       '/* Spooler service not started                                        */
Public Const ERR_SPL_PAUSED& = -370                          '/* Spooler service paused                                             */
Public Const ERR_RESET& = -400                               '/* Now printer is resetting                                           */
Public Const ERR_THREAD& = -420                              '/* Failure to the start of Thread                                     */
Public Const ERR_ABORT& = -430                               '/* Because BiSCNMICRCancelFunction was called, processing was stopped */
Public Const ERR_MICR& = -440                                '/* Error occurred during MICR processing                              */
Public Const ERR_SCAN& = -450                                '/* Error occurred during the image scan                               */
Public Const ERR_LINE_OVERFLOW& = -460                       '/* A line overflow has occurred during transaction printing           */
Public Const ERR_NOT_EXEC& = -470                            '/* Processing is not executed                                         */
Public Const ERR_DATA_INVALID& = -480
Public Const ERR_SIZE& = -1000                               '/* Size excess error                                                  */
Public Const ERR_PAPER_PILED& = -1010                        '/* Paper pilling error                                                */
Public Const ERR_PAPER_JAM& = -1020                          '/* Paper jam has occurred                                             */
Public Const ERR_COVER_OPEN& = -1030                         '/* Cover open error                                                   */
Public Const ERR_MICR_NODATA& = -1040                        '/* MICR data is not existing                                          */
Public Const ERR_MICR_BADDATA& = -1050                       '/* MICR data is not able to recognize                                 */
Public Const ERR_MICR_PARSE& = -1060                         '/* MICR data can not be parsed                                        */
Public Const ERR_MICR_NOISE& = -1070                         '/* Noise error has occurred during MICR reading                       */
Public Const ERR_SCN_COMPRESS& = -1080                       '/* Scan image data compressing error                                  */
Public Const ERR_PAPER_EXIST& = -1090                        '/* Because there is a paper on the path, API can not be execute       */
Public Const ERR_PAPER_INSERT& = -1100                       '/* Paper insertion error                                              */
Public Const ERR_LESS_CHECKS& = -1110
Public Const ERR_SCN_IQA& = -1120                            '/* IQA not pass                                                       */
Public Const ERR_BARCODE_NODATA& = -1130                     '/* Barcode data is not existing                                       */
Public Const ERR_UNLOCKED& = -1140                           '/* Port Unlocked                                                      */
Public Const ERR_NET_CONNECTED& = -1150                      '/* Network connection fails                                           */
Public Const ERR_MSRW_NODATA& = -1160                        '/* MSR data is not existing                                           */
Public Const ERR_IMAGE_FILEREMOVE& = -1170                   '/* Remove failure                                                     */
Public Const ERR_PRINT_DATA_LENGTH_EXCEED& = -1180           '/* Printing data length exceeds the paper size                        */
Public Const ERR_PRINT_DATA_UNRECEIVE& = -1190               '/* Printing data is not received                                      */
Public Const ERR_EXEC_SCAN_CHECK_CONTINUOUS& = -2000         '/* Now scanning check continuous mode                                 */
Public Const ERR_EXEC_SCAN_CHECK_ONEBYONE& = -2010           '/* Now scanning check one by one mode                                 */
Public Const ERR_EXEC_SCAN_IDCARD& = -2020                   '/* Now scanning ID card                                               */
Public Const ERR_EXEC_PRINT_ROLLPAPER& = -2030               '/* Now printing text, image or barcode on roll paper                  */
Public Const ERR_EXEC_PRINT_VALIDATION& = -2040              '/* Now printing text, image or barcode on validation                 */


'/******************************************************************************/
'/******************************************************************************/
'/* ASB Bit                                                                    */
'/******************************************************************************/
'/******************************************************************************/
Public Const ASB_NO_RESPONSE& = &H1                                         '/* No response                            */
Public Const ASB_PRINT_SUCCESS& = &H2                                       '/* Finish to print                        */
Public Const ASB_DRAWER_KICK& = &H4                                         '/* Drawer kick-out connector pin3 is HIGH */
Public Const ASB_OFF_LINE& = &H8                                            '/* Off-line                               */
Public Const ASB_COVER_OPEN& = &H20                                         '/* Cover is open                          */
Public Const ASB_PAPER_FEED& = &H40                                         '/* Paper is now feeding by PF FW          */
Public Const ASB_WAIT_PEPRT_EJECT& = &H100                                  '/* Waiting for slip remove                */
Public Const ASB_PANEL_SWITCH& = &H200                                      '/* Panel switch                           */
Public Const ASB_MECHANICAL_ERR& = &H400                                    '/* Mechanical error                       */
Public Const ASB_AUTOCUTTER_ERR& = &H800                                    '/* Auto cutter error                      */
Public Const ASB_UNRECOVER_ERR& = &H2000                                    '/* Unrecoverable error                    */
Public Const ASB_AUTORECOVER_ERR& = &H4000                                  '/* Auto-Recoverable error                 */
Public Const ASB_NOT_CARD_INSERT& = &H10000                                 '/* Not card insert                        */
Public Const ASB_RECEIPT_NEAR_END& = &H20000                                '/* Receipt paper roll near-end            */
Public Const ASB_MAIN_NEAR_FULL& = &H20000                                  '/* Main Pocket not Near Full              */
Public Const ASB_EJECT_SENSOR_NO_PAPER& = &H40000                           '/* Eject sensor no paper                  */
Public Const ASB_RECEIPT_END& = &H80000                                     '/* Receipt paper roll end                 */
Public Const ASB_SUB_NEAR_FULL& = &H80000                                   '/* Sub Pocket not Near Full               */
Public Const ASB_PAPER_INTERMEDIATE& = &H200000                             '/* Not paper in Paper intermediate sensor */
Public Const ASB_SLIP_TOF& = &H200000                                       '/* SLIP TOF                               */
Public Const ASB_ASF_PAPER& = &H400000                                      '/* No paper ASF                           */
Public Const ASB_SLIP_SELECTED& = &H1000000                                 '/* Slip is not selected                   */
Public Const ASB_PRINT_SLIP& = &H2000000                                    '/* Cannot print on slip                   */
Public Const ASB_STAMP_EXIST& = &H2000000                                   '/* Stamp not Exist                        */
Public Const ASB_VALIDATION_SELECTED& = &H4000000                           '/* Validation is not selected             */
Public Const ASB_PRINT_VALIDATION& = &H8000000                              '/* Cannot print on validation             */
Public Const ASB_WAIT_INSERT& = &H20000000                                  '/* Wait insert                            */
Public Const ASB_SLIP_PAPER_SIZE& = &H40000000                              '/* Not paper in Slip Paper size sensor    */
Public Const ASB_VALIDATION_NO_PAPER& = &H40000000                          '/* Validation no paper                    */
Public Const ASB_FRANKING_SENSOR& = &H40000000                              '/* Not paper in Franking sensor           */

Public Const INK_ASB_NEAR_END& = &H1                                        '/* Ink Low                                */
Public Const INK_ASB_END& = &H2                                             '/* Replace Ink Cartridge                  */
Public Const INK_ASB_NO_CARTRIDGE& = &H4                                    '/* Cartridge is not present               */
Public Const INK_ASB_NO_CARTRIDGE2& = &H8                                   '/* Cartridge2 is not present              */
Public Const INK_ASB_CLEANING& = &H20                                       '/* Being cleaned                          */
Public Const INK_ASB_NEAR_END2& = &H100                                     '/* Ink Low2                               */
Public Const INK_ASB_END2& = &H200                                          '/* Replace Ink Cartridge2                 */


'/******************************************************************************/
'/******************************************************************************/
'/* Function Parameter                                                         */
'/******************************************************************************/
'/******************************************************************************/
'/*============================*/
'/* BiOpenMonPrinter()                                     */
'/*============================*/
'/*------------------------------------*/
'/* Open Type                          */
'/*------------------------------------*/
Public Const TYPE_PORT& = 1                                     '/* use port name           */
Public Const TYPE_PRINTER& = 2                                  '/* use printer driver name */

'/*============================*/
'/* BiMICRSelectDataHandling()                             */
'/*============================*/
'/*------------------------------------*/
'/* Error Select                       */
'/*------------------------------------*/
Public Const ES_STOP_ALL& = &H0
Public Const ES_CONTINUE_ALL& = &H1
Public Const ES_CONTINUE_DOUBLEFEED& = &H2
Public Const ES_CONTINUE_NODATA& = &H4
Public Const ES_CONTINUE_BADDATA& = &H8
Public Const ES_CONTINUE_NOISE& = &H10

'/*============================*/
'/* BiSCNSetImageQuality()                                 */
'/*============================*/
'/*------------------------------------*/
'/* Scale Option                       */
'/*------------------------------------*/
Public Const EPS_BI_SCN_1BIT& = 1                               '/* Monochrome */
Public Const EPS_BI_SCN_8BIT& = 8                               '/* Gray scale */
Public Const EPS_BI_SCN_24BIT& = 24                             '/* RGB 24bit  */
'/*------------------------------------*/
'/* Color Option                       */
'/*------------------------------------*/
Public Const EPS_BI_SCN_MONOCHROME& = 48                        '/* Monochrome */
Public Const EPS_BI_SCN_COLOR& = 49                             '/* Color      */
'/*------------------------------------*/
'/* Extensive Option                   */
'/*------------------------------------*/
Public Const EPS_BI_SCN_MANUAL& = 49                            '/* Manual                                           */
Public Const EPS_BI_SCN_SHARP& = 50                             '/* Sharpness                                        */
Public Const EPS_BI_SCN_SHARP_CUSTOM& = 51                      '/* Custom sharpness                                 */
Public Const EPS_BI_SCN_SHARP_CUSTOM2& = 52                     '/* Combination of sharpness and custom sharpness    */
Public Const EPS_BI_SCN_SHARP_CUSTOM3& = 53                     '/* Sharpness(eliminate checkered patterns)          */

'/*============================*/
'/* BiSCNSetImageFormat()                                  */
'/*============================*/
'/*------------------------------------*/
'/* Format Option                      */
'/*------------------------------------*/
Public Const EPS_BI_SCN_TIFF& = 1                               '/* TIFF format(CCITT Group 4)   */
Public Const EPS_BI_SCN_RASTER& = 2                             '/* Raster Image                 */
Public Const EPS_BI_SCN_BITMAP& = 3                             '/* Bitmap                       */
Public Const EPS_BI_SCN_TIFF256& = 4                            '/* TIFF format(Gray scale)      */
Public Const EPS_BI_SCN_JPEGHIGH& = 5                           '/* Jpeg format(High compressed) */
Public Const EPS_BI_SCN_JPEGNORMAL& = 6                         '/* Jpeg format(Normal)          */
Public Const EPS_BI_SCN_JPEGLOW& = 7                            '/* Jpeg format(Low compressed)  */
Public Const EPS_BI_SCN_JTIFF& = 8                              '/* TIFF format(Jpeg compressed) */

'/*============================*/
'/* BiSCNSelectScanUnit()                                  */
'/*============================*/
Public Const EPS_BI_SCN_UNIT_CHECKPAPER& = 48                   '/* Checkpaper scanner unit */
Public Const EPS_BI_SCN_UNIT_CARD& = 49                         '/* Card scanner unit       */

'/*============================*/
'/* BiSCNSelectScanFace()                                  */
'/*============================*/
Public Const MF_SCAN_FACE_FRONT& = 0
Public Const MF_SCAN_FACE_BACK& = 1

'/*============================*/
'/* BiGetOcrABText()                                       */
'/*============================*/
Public Const OCR_SOURCE_TRANSACTION_NUMBER& = 0
Public Const OCR_SOURCE_IMAGE_FILE& = 1

'/*============================*/
'/* BiSetPrintStation()                                    */
'/*============================*/
'/*------------------------------------*/
'/* Printing Station                   */
'/*------------------------------------*/
Public Const MF_ST_ROLLPAPER& = &H1                                         '/* Roll paper printing                   */
Public Const MF_ST_VALIDATION& = &H2                                        '/* Validation printing                   */
Public Const MF_ST_E_ENDORSEMENT& = &H4                                     '/* Electric endorse printing             */
Public Const MF_ST_E_ENDORSEMENT_BACK& = MF_ST_E_ENDORSEMENT                '/* Electric endorse printing(back side)  */
Public Const MF_ST_E_ENDORSEMENT_FRONT& = &H8                               '/* Electric endorse printing(front side) */
Public Const MF_ST_PHYSICAL_ENDORSEMENT& = &H10
Public Const MF_ST_FEEDER& = &H20

'/*============================*/
'/* BiPrintBarCode()                                       */
'/*============================*/
'/*------------------------------------*/
'/* Symbol                             */
'/*------------------------------------*/
Public Const CODE_UPCA& = 101
Public Const CODE_UPCE& = 102
Public Const CODE_EAN8& = 103
Public Const CODE_EAN13& = 104
Public Const CODE_ITF& = 106
Public Const CODE_CODABAR& = 107
Public Const CODE_CODE39& = 108
Public Const CODE_CODE93& = 109
Public Const CODE_CODE128& = 110
Public Const CODE_GS1_DATABAR_OMINIDIRECTIONAL& = 112
Public Const CODE_GS1_DATABAR_TRUNCATED& = 113
Public Const CODE_GS1_DATABAR_LIMITED& = 114
Public Const CODE_GS1_DATABAR_EXPANDED& = 115
Public Const CODE_PDF417& = 116
Public Const CODE_QRCODE& = 117
Public Const CODE_MAXICODE& = 118
Public Const CODE_GS1_DATABAR_STACKED& = 119
Public Const CODE_GS1_DATABAR_STACKED_OMINIDIRECTIONAL& = 120
Public Const CODE_GS1_DATABAR_EXPANDED_STACKED& = 121
Public Const CODE_COMPOSIT& = &H10000000
'/*------------------------------------*/
'/* Text Position                      */
'/*------------------------------------*/
Public Const HRI_NONE& = -11
Public Const HRI_ABOVE& = -12
Public Const HRI_BELOW& = -13

'/*============================*/
'/* BiSetPrintAlignment()                                  */
'/*============================*/
Public Const MF_PRINT_ALIGNMENT_LEFT& = -1
Public Const MF_PRINT_ALIGNMENT_CENTER& = -2
Public Const MF_PRINT_ALIGNMENT_RIGHT& = -3

'/*============================*/
'/* BiBufferedPrint()                                      */
'/*============================*/
Public Const MF_PRT_BUFFERING& = 1
Public Const MF_PRT_EXEC& = 2
Public Const MF_PRT_CLEAR& = 3

'/*============================*/
'/* BiSelectJamDetect()                                    */
'/*============================*/
Public Const EPS_BI_JAM_DETECT_USE_UPPER_LEFT_SENSOR& = 0
Public Const EPS_BI_JAM_DETECT_NOT_USE_UPPER_LEFT_SENSOR& = 1

'/*============================*/
'/* BiRingBuzzer()                                         */
'/*============================*/
Public Const MF_BUZZER_TONE_HIGH& = 0
Public Const MF_BUZZER_TONE_MIDDLE& = 2
Public Const MF_BUZZER_TONE_LOW& = 1

'/*============================*/
'/* BiSCNSetBehaviorToSclResult()                          */
'/*============================*/
'/*------------------------------------*/
'/* Next Check                         */
'/*------------------------------------*/
Public Const MF_PROCESS_CONTINUE_OVERLAP& = 1
Public Const MF_PROCESS_CONTINUE_NOOVERLAP& = 2
Public Const MF_PROCESS_CONTINUE_CANCEL& = 3

'/*============================*/
'/* BiGetVersion()                                         */
'/*============================*/
'/*------------------------------------*/
'/* Driver Type                        */
'/*------------------------------------*/
Public Const DRIVER_TYPE_S9000& = 4
Public Const DRIVER_TYPE_S2000& = 5
'/*------------------------------------*/
'/* Type                               */
'/*------------------------------------*/
Public Const VERSION_TYPE_DRIVER& = &H1
Public Const VERSION_TYPE_USB& = &H2
Public Const VERSION_TYPE_MICR& = &H3
Public Const VERSION_TYPE_MICR_E13B& = &H3
Public Const VERSION_TYPE_MICR_CMC7& = &H10003
Public Const VERSION_TYPE_OCR& = &H4
Public Const VERSION_TYPE_IMAGE& = &H5
Public Const VERSION_TYPE_IQA& = &H6
Public Const VERSION_TYPE_BARCODE& = &H7
Public Const VERSION_TYPE_PH& = &H11
Public Const VERSION_TYPE_MICR_PARSING& = &H12
Public Const VERSION_TYPE_LBLBARCODE& = &H13
Public Const VERSION_TYPE_BMPTORASTER& = &H14

'/*============================*/
'/* BiMICRClearSpaces()                                    */
'/*============================*/
Public Const CLEAR_SPACE_DISABLE& = 0
Public Const CLEAR_SPACE_ENABLE& = 1

'/*============================*/
'/* BiSetOcrABAreaOrigin()                                 */
'/*============================*/
Public Const OCR_ORIGIN_TOP_LEFT& = 0
Public Const OCR_ORIGIN_BOTTOM_LEFT& = 1
Public Const OCR_ORIGIN_TOP_RIGHT& = 2
Public Const OCR_ORIGIN_BOTTOM_RIGHT& = 3

'/*============================*/
'/* BiSetEndorseDirection()                                */
'/*============================*/
Public Const EENDORSE_DIRECTION_LEFTRIGHT& = 1
Public Const EENDORSE_DIRECTION_TOPBOTTOM& = 2
Public Const EENDORSE_DIRECTION_RIGHTLEFT& = 3
Public Const EENDORSE_DIRECTION_BOTTOMTOP& = 4

'/*============================*/
'/* BiSCNSetImageTypeOption()                              */
'/*============================*/
Public Const EPS_BI_SCN_OPTION_COLOR& = 0
Public Const EPS_BI_SCN_OPTION_IR& = 1
Public Const EPS_BI_SCN_OPTION_DROPOUT_RED& = 2
Public Const EPS_BI_SCN_OPTION_DROPOUT_GREEN& = 3
Public Const EPS_BI_SCN_OPTION_DROPOUT_BLUE& = 4
Public Const EPS_BI_SCN_OPTION_COLOR_ENHANCEMENT_RED& = 5
Public Const EPS_BI_SCN_OPTION_COLOR_ENHANCEMENT_GREEN& = 6
Public Const EPS_BI_SCN_OPTION_COLOR_ENHANCEMENT_BLUE& = 7
Public Const EPS_BI_SCN_OPTION_COLOR_IR& = 8
Public Const EPS_BI_SCN_OPTION_GRAYSCALE& = 9
Public Const EPS_BI_SCN_OPTION_GRAYSCALE_IR& = 10
Public Const EPS_BI_SCN_OPTION_DROPOUT_RED_IR& = 11
Public Const EPS_BI_SCN_OPTION_DROPOUT_GREEN_IR& = 12
Public Const EPS_BI_SCN_OPTION_DROPOUT_BLUE_IR& = 13

'/*============================*/
'/* BiSCNSetImageAdjustment()                              */
'/*============================*/
'/*------------------------------------*/
'/* Brightness                         */
'/*------------------------------------*/
Public Const EPS_BI_SCN_BRIGHTNESS_DEFAULT& = 0
Public Const EPS_BI_SCN_BRIGHTNESS_NONE& = EPS_BI_SCN_BRIGHTNESS_DEFAULT
'/*------------------------------------*/
'/* Contrast                           */
'/*------------------------------------*/
Public Const EPS_BI_SCN_CONTRAST_DEFAULT& = 0
Public Const EPS_BI_SCN_CONTRAST_NONE& = EPS_BI_SCN_CONTRAST_DEFAULT
'/*------------------------------------*/
'/* Gamma                              */
'/*------------------------------------*/
Public Const EPS_BI_SCN_GAMMA_NONE& = 0
Public Const EPS_BI_SCN_GAMMA_DEFAULT& = 22
Public Const EPS_BI_SCN_GAMMA_10& = 10
Public Const EPS_BI_SCN_GAMMA_18& = 18
Public Const EPS_BI_SCN_GAMMA_22& = 22

'/*============================*/
'/* BiSCNMICRCancelFunction                                */
'/*============================*/
Public Const MF_EJECT_DISCHARGE& = &H0
Public Const MF_EJECT_RELEASE& = &H1

'/*============================*/
'/* BiSetWaterfallMode()                                   */
'/*============================*/
Public Const WATERFALL_MODE_DISABLE& = 0
Public Const WATERFALL_MODE_STANDARD& = 1
Public Const WATERFALL_MODE_INHERIT_POCKET& = 2

'/*============================*/
'/* BiSelectErrorEjectAtContinuously()                     */
'/*============================*/
'/*------------------------------------*/
'/* Error                              */
'/*------------------------------------*/
Public Const EPS_BI_ERROREJECT_ERROR_ALL& = ES_CONTINUE_ALL
Public Const EPS_BI_ERROREJECT_ERROR_DOUBLEFEED& = ES_CONTINUE_DOUBLEFEED
Public Const EPS_BI_ERROREJECT_ERROR_NODATA& = ES_CONTINUE_NODATA
Public Const EPS_BI_ERROREJECT_ERROR_BADDATA& = ES_CONTINUE_BADDATA
Public Const EPS_BI_ERROREJECT_ERROR_NOISE& = ES_CONTINUE_NOISE
'/*------------------------------------*/
'/* Setting                            */
'/*------------------------------------*/
Public Const EPS_BI_ERROREJECT_SETTING_DISCHARGE& = MF_EJECT_DISCHARGE
Public Const EPS_BI_ERROREJECT_SETTING_RELEASE& = MF_EJECT_RELEASE

'/*============================*/
'/* BiAutoCutRollPaper()                                   */
'/*============================*/
Public Const AUTOCUT_CUT& = 0
Public Const AUTOCUT_FEEDANDCUT& = 1

'/*============================*/
'/* BiSetPrintImageMethod()                                */
'/*============================*/
Public Const PRINTIMAGEMETHOD_BW& = 0
Public Const PRINTIMAGEMETHOD_MULTITONE& = 1

'/*============================*/
'/* BiOpenDrawer()                                         */
'/*============================*/
'/*------------------------------------*/
'/* Drawer Number                      */
'/*------------------------------------*/
Public Const EPS_BI_DRAWER_1& = 1
'/*------------------------------------*/
'/* Start Time                         */
'/*------------------------------------*/
Public Const EPS_BI_PLUSE_100& = 1
Public Const EPS_BI_PLUSE_200& = 2
Public Const EPS_BI_PLUSE_300& = 3
Public Const EPS_BI_PLUSE_400& = 4
Public Const EPS_BI_PLUSE_500& = 5
Public Const EPS_BI_PLUSE_600& = 6
Public Const EPS_BI_PLUSE_700& = 7
Public Const EPS_BI_PLUSE_800& = 8

'/*========================================================*/
'/* BiTemplatePrint()                                      */
'/*========================================================*/
Public Const TEMPLATEPRINT_BUFFERING& = 0
Public Const TEMPLATEPRINT_EXEC& = 1
Public Const TEMPLATEPRINT_CLEAR& = 2
Public Const TEMPLATEPRINT_EXEC_NOCLEAR& = 3

'/*========================================================*/
'/* BiSetTemplatePrintArea()                               */
'/* BiClearTemplatePrintArea()                             */
'/*========================================================*/
Public Const TRANS_NO_SPECIFIED& = &H40000000

'/*============================*/
'/* BiSetPrintCutSheetSettings()                           */
'/*============================*/
Public Const BI_PRINTCUTSHEET_SCAN& = 0
Public Const BI_PRINTCUTSHEET_NOSCAN& = 1

'/*============================*/
'/* BiSetTemplatePrintArea()                                       */
'/*============================*/
Public Const SELECTPRINTAREA_AREANAME& = 0
Public Const SELECTPRINTAREA_DIRECT& = 1

'/*============================*/
'/* BiSCNSelectScanImage()                                    */
'/*============================*/
Public Const MF_SCAN_IMAGE_VISIBLE& = 0
Public Const MF_SCAN_IMAGE_INFRARED& = 1

'/*============================*/
'/* BiESCNEnable()                                         */
'/*============================*/
'/*------------------------------------*/
'/* Saved Method                       */
'/*------------------------------------*/
Public Const CROP_STORE_MEMORY& = 0                             '/* Saved memory */
Public Const CROP_STORE_FILE& = 1                               '/* Saved file   */

'/*============================*/
'/* BiESCNSetAutoSize()                                    */
'/*============================*/
'/*------------------------------------*/
'/* Enable/Disable Autosize            */
'/*------------------------------------*/
Public Const CROP_AUTOSIZE_DISABLE& = 0                         '/* Disabled auto size  */
Public Const CROP_AUTOSIZE_ENABLE& = 1                          '/* Enabled auto size */

'/*============================*/
'/* BiESCNSetRotate()                                      */
'/*============================*/
'/*------------------------------------*/
'/* Enable/Disable Rotate              */
'/*------------------------------------*/
Public Const CROP_ROTATE_DISABLE& = 0                                            '/* Enabled rotate */
Public Const CROP_ROTATE_ENABLE& = 1                                             '/* Disabled rotate */

'/*============================*/
'/* BiESCNGetDeSkew(), BiESCNSetDeSkew()                   */
'/*============================*/
Public Const DESKEW_ALL& = 0
Public Const DESKEW_DISABLE& = 65535

'/*============================*/
'/* BiESCNDefineCropArea()                                 */
'/*============================*/
'/*------------------------------------*/
'/* CropArea Setting                   */
'/*------------------------------------*/
Public Const CROP_AREA_RESET_ALL& = 0                           '/* Delete all crop area  */
Public Const CROP_AREA_ENTIRE_IMAGE& = 1                        '/* CropArea entire image */
Public Const CROP_AREA_RIGHT& = 65535                           '/* End X Point           */
Public Const CROP_AREA_BOTTOM& = 65535                          '/* End Y Point           */

'/*============================*/
'/* BiESCNClearImage()                                     */
'/*============================*/
'/*------------------------------------*/
'/* Delete Method                      */
'/*------------------------------------*/
Public Const CROP_CLEAR_ALL_IMAGE& = 0                          '/* Delete all image   */
Public Const CROP_CLEAR_BY_FILEINDEX& = 1                       '/* Clear by fileIndex */
Public Const CROP_CLEAR_BY_FILEID& = 2                          '/* Clear by fileId    */
Public Const CROP_CLEAR_BY_IMAGETAGDATA& = 4                    '/* by imageTagData    */

'/*============================*/
'/* BiSCNMICRFunction                                      */
'/*============================*/
'/*------------------------------------*/
'/* Message ID                         */
'/*------------------------------------*/
Public Const WM_USER& = &H400
Public Const WM_MF_DONE& = (WM_USER + 1)
Public Const WM_MF_PROGRESS& = (WM_USER + 2)

'/*------------------------------------*/
'/* Param                              */
'/*------------------------------------*/
'Public Const     MF_MACRO_GETUNITID(wParam)      LOBYTE(HIWORD(wParam))
'Public Const     MF_MACRO_GETPHASE(wParam)       LOBYTE(LOWORD(wParam))
'Public Const     MF_MACRO_GETFACE(lParam)        LOBYTE(HIWORD(lParam))
'Public Const     MF_MACRO_PERCENT(lParam)        LOBYTE(LOWORD(lParam))

Public Const MF_PHASE_INIT& = 0
Public Const MF_PHASE_MICR& = 1
Public Const MF_PHASE_SCAN& = 2
Public Const MF_PHASE_PRINT& = 3
Public Const MF_PHASE_EXIT& = 4
Public Const MF_PHASE_BARCODE& = 5

Public Const MF_PROGRESS_START& = 0
Public Const MF_PROGRESS_DONE& = 100
Public Const MF_PROGRESS_WAIT_PAPER& = 101
Public Const MF_PROGRESS_CLUMP_PAPER& = 102
Public Const MF_PROGRESS_PAPER_PILED& = 103

'/*============================*/
'/* BiSCNMICRSetStatusBackFunction                         */
'/*============================*/
'/*------------------------------------*/
'/* wMainStatus                        */
'/*------------------------------------*/
Public Const MF_FUNCTION_START& = 200
Public Const MF_CHECKPAPER_PROCESS_START& = 201
Public Const MF_DATARECEIVE_START& = 202
Public Const MF_DATARECEIVE_DONE& = 203
Public Const MF_CHECKPAPER_PROCESS_DONE& = 204
Public Const MF_FUNCTION_DONE& = 205
Public Const MF_DATARECEIVE_MICR_DONE& = 206
Public Const MF_ERROR_OCCURED& = 299

'/*============================*/
'/* BiSCNMICRFunction                                      */
'/* BiSCNMICRFunctionContinuously                          */
'/* BiSCNMICRFunctionPostPrint                             */
'/* BiPrintCutSheet                                        */
'/*============================*/
'/*------------------------------------*/
'/* wFunction                          */
'/*------------------------------------*/
Public Const MF_EXEC& = &H0
Public Const MF_CONTINUE& = &H1
Public Const MF_MICR_RETRANS& = &H2
Public Const MF_SCAN_FRONT_RETRANS& = &H3
Public Const MF_SCAN_BACK_RETRANS& = (MF_SCAN_FRONT_RETRANS + 1)

Public Const MF_SET_BASE_PARAM& = &H10
Public Const MF_SET_MICR_PARAM& = &H11
Public Const MF_SET_SCAN_FRONT_PARAM& = &H12
Public Const MF_SET_SCAN_PARAM& = &H12
Public Const MF_SET_SCAN_BACK_PARAM& = (MF_SET_SCAN_FRONT_PARAM + 1)
Public Const MF_SET_PRINT_PARAM& = &H14
Public Const MF_SET_PROCESS_PARAM& = &H15
Public Const MF_SET_IQA_PARAM& = &H16
Public Const MF_SET_BARCODE_FRONT_PARAM& = &H17
Public Const MF_SET_BARCODE_PARAM& = &H17
Public Const MF_SET_BARCODE_BACK_PARAM& = (MF_SET_BARCODE_FRONT_PARAM + 1)

Public Const MF_CLEAR_BASE_PARAM& = &H20
Public Const MF_CLEAR_MICR_PARAM& = &H21
Public Const MF_CLEAR_SCAN_FRONT_PARAM& = &H22
Public Const MF_CLEAR_SCAN_PARAM& = &H22
Public Const MF_CLEAR_SCAN_BACK_PARAM& = (MF_CLEAR_SCAN_FRONT_PARAM + 1)
Public Const MF_CLEAR_PRINT_PARAM& = &H24
Public Const MF_CLEAR_PROCESS_PARAM& = &H25
Public Const MF_CLEAR_IQA_PARAM& = &H26
Public Const MF_CLEAR_BARCODE_FRONT_PARAM& = &H27
Public Const MF_CLEAR_BARCODE_PARAM& = &H27
Public Const MF_CLEAR_BARCODE_BACK_PARAM& = (MF_CLEAR_BARCODE_FRONT_PARAM + 1)

Public Const MF_GET_BASE_DEFAULT& = &H30
Public Const MF_GET_MICR_DEFAULT& = &H31
Public Const MF_GET_SCAN_DEFAULT& = &H32
Public Const MF_GET_SCAN_FRONT_DEFAULT& = &H32
Public Const MF_GET_SCAN_BACK_DEFAULT& = (MF_GET_SCAN_FRONT_DEFAULT + 1)
Public Const MF_GET_PRINT_DEFAULT& = &H34
Public Const MF_GET_PROCESS_DEFAULT& = &H35
Public Const MF_GET_IQA_DEFAULT& = &H36
Public Const MF_GET_BARCODE_DEFAULT& = &H37
Public Const MF_GET_BARCODE_FRONT_DEFAULT& = &H37
Public Const MF_GET_BARCODE_BACK_DEFAULT& = (MF_GET_BARCODE_FRONT_DEFAULT + 1)

Public Const MF_SET_SCAN_PRINTAREA_PARAM& = MF_SET_SCAN_BACK_PARAM
Public Const MF_SET_SCAN_NOPRINTAREA_PARAM& = MF_SET_SCAN_FRONT_PARAM
Public Const MF_CLEAR_SCAN_PRINTAREA_PARAM& = MF_CLEAR_SCAN_BACK_PARAM
Public Const MF_CLEAR_SCAN_NOPRINTAREA_PARAM& = MF_SET_SCAN_FRONT_PARAM
Public Const MF_GET_SCAN_PRINTAREA_DEFAULT& = MF_GET_SCAN_BACK_DEFAULT
Public Const MF_GET_SCAN_NOPRINTAREA_DEFAULT& = MF_GET_SCAN_FRONT_DEFAULT


'/*========================================================*/
'/* BiLoadAPISettings()                                    */
'/*========================================================*/
'/*------------------------------------*/
'/* Default                            */
'/*------------------------------------*/
Public Const APISETTINGS_DEFAULT As String = "APISETTINGSDEFAULT"

'/*========================================================*/
'/* BiSetConfigure()                                       */
'/*========================================================*/
'/*------------------------------------*/
'/* Confing ID                         */
'/*------------------------------------*/
Public Const MF_CONFIG_ID_2ND_RECEIPT& = 0
Public Const MF_CONFIG_ID_SCAN_LENGTH& = 1
Public Const MF_CONFIG_ID_MICR_RECOG& = 2
Public Const MF_CONFIG_ID_ENDORSE_PRINT_POSITION& = 3
'/*------------------------------------*/
'/* Config Type (2nd Reciept)          */
'/*------------------------------------*/
Public Const MF_CONFIG_TYPE_2ND_RECEIPT_DISABLE& = 0
Public Const MF_CONFIG_TYPE_2ND_RECEIPT_ENABLE& = 1
'/*------------------------------------*/
'/* Config Type (Scan Length)          */
'/*------------------------------------*/
Public Const MF_CONFIG_TYPE_SCAN_LENGTH_NORMAL& = 0
Public Const MF_CONFIG_TYPE_SCAN_LENGTH_EXPAND& = 1
'/*------------------------------------*/
'/* Config Type (MICR Recog)          */
'/*------------------------------------*/
Public Const MF_CONFIG_TYPE_MICR_RECOG_ANSI& = 0
Public Const MF_CONFIG_TYPE_MICR_RECOG_CCCC& = 1
'/*------------------------------------*/
'/* Config Type (Endorse Print Position )*/
'/*------------------------------------*/
Public Const MF_CONFIG_TYPE_ENDORSE_PRINT_POSITION_NORMAL& = 0
Public Const MF_CONFIG_TYPE_ENDORSE_PRINT_POSITION_PAYEE_ENDORSE& = 1


'/******************************************************************************/
'/******************************************************************************/
'/* MF Fuction Structure                                                       */
'/******************************************************************************/
'/******************************************************************************/
'#if defined(WIN32)
'#pragma pack(push, 1)   '/* set structure packing to 1 */
'#End If

'/*============================*/
'/* Base parameters                                        */
'/*============================*/
'/*------------------------------------*/
'/* struct version(for iVersion)       */
'/*------------------------------------*/
Public Const MF_FIRST_VERSION& = &H100
Public Const MF_BASE_VERSION01& = &H101
Public Const MF_BASE_VERSION& = MF_FIRST_VERSION
'/*------------------------------------*/
'/* Event notice type(for dwNotifyType)*/
'/*------------------------------------*/
Public Const MF_BASE_MESSAGE_NO_MESSAGE& = 1
Public Const MF_BASE_MESSAGE_EVENT& = 2
Public Const MF_BASE_MESSAGE_HWND& = 3
Public Const MF_BASE_MESSAGE_BUTTON_CLICK& = 4
Public Const MF_BASE_MESSAGE_NOTIFY_MAX& = MF_BASE_MESSAGE_BUTTON_CLICK
'/*------------------------------------*/
'/* Paper insertion timeout            */
'/* (for dwTimeout)                    */
'/*------------------------------------*/
Public Const MF_BASE_TIMEOUT_MAX& = 300                     '/* 5 min    */
Public Const MF_BASE_TIMEOUT_DEFAULT& = 0                   '/* INFINITE */
'/*------------------------------------*/
'/* NV memory use type                 */
'/* (for bUseNVMemory)                 */
'/*------------------------------------*/
Public Const MF_BASE_NVMEMORY_NOT_USE& = 0
Public Const MF_BASE_NVMEMORY_USE& = 1
'/*------------------------------------*/
'/* Paper eject type                   */
'/* (for wErrorEject and wSuccessEject)*/
'/*------------------------------------*/
Public Const MF_EXIT_ERROR_DISCHARGE& = MF_EJECT_DISCHARGE
Public Const MF_EXIT_ERROR_RELEASE& = MF_EJECT_RELEASE
Public Const MF_EXIT_SUCCESS_DISCHARGE& = MF_EJECT_DISCHARGE
Public Const MF_EXIT_SUCCESS_RELEASE& = MF_EJECT_RELEASE
Public Const MF_EXIT_ERROR_CONTINUE_DISCHARGE& = &H10
Public Const MF_EXIT_ERROR_CONTINUE_RELEASE& = &H11
'/*------------------------------------*/
'/* Buzzer factor type(for index of bBuzzerHz and bBuzzerCount)  */
'/*------------------------------------*/
Public Const MF_BUZZER_TYPE_SUCCESS& = 1
Public Const MF_BUZZER_TYPE_ERROR& = 2
Public Const MF_BUZZER_TYPE_WFEED& = 3
Public Const MF_BUZZER_TYPE_MAX& = 3
'/*------------------------------------*/
'/* Buzzer type(for bBuzzerHz)         */
'/*------------------------------------*/
Public Const MF_BUZZER_HZ_4000& = 0
Public Const MF_BUZZER_HZ_440& = 1
Public Const MF_BUZZER_HZ_880& = 2
'/*------------------------------------*/
'/* Buzzer count(for bBuzzerCount)     */
'/*------------------------------------*/
Public Const MF_BUZZER_DISABLE& = 0
Public Const MF_BUZZER_COUNT_MAX& = 3
'/*------------------------------------*/
'/* Base Structure(Version& = &H0101)     */
'/*------------------------------------*/
Public Type MF_BASE01
Rem:'// Base Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        dwNotifyType(1 To 4) As Byte
        dwTimeout(1 To 4) As Byte
        uNotifyHandle(1 To 4) As Byte
        hProgressWnd(1 To 4) As Byte
        wErrorEject(1 To 2) As Byte
        bBuzzerHz(1 To MF_BUZZER_TYPE_MAX) As Byte
        bBuzzerCount(1 To MF_BUZZER_TYPE_MAX) As Byte
        bUseNVMemory As Byte
        cPortName(1 To 256) As Byte
        wSuccessEject(1 To 2) As Byte
End Type
'/*------------------------------------*/
'/* Base Structure(OLD:Version& = &H0100) */
'/*------------------------------------*/
Public Type MF_BASE
Rem:'// Base Section
        iSize As Long
        iVersion As Long
        iRet As Long
        dwNotifyType As Long
        dwTimeout As Long
        uNotifyHandle As Long
        hProgressWnd As Object
        wErrorEject As Integer
        bBuzzerHz(MF_BUZZER_TYPE_MAX) As Byte
        bBuzzerCount(MF_BUZZER_TYPE_MAX) As Byte
        bUseNVMemory As Byte
        cPortName(256) As Byte
End Type

'/*============================*/
'/* Scan parameters                                        */
'/*============================*/
'/*------------------------------------*/
'/* Structure version                  */
'/*------------------------------------*/
Public Const MF_SCAN_VERSION& = &H100
'/*------------------------------------*/
'/* Scan resolution(for sResolution)   */
'/*------------------------------------*/
Public Const MF_SCAN_DPI_DEFAULT& = 0
Public Const MF_SCAN_DPI_100& = 100
Public Const MF_SCAN_DPI_120& = 120
Public Const MF_SCAN_DPI_200& = 200
Public Const MF_SCAN_DPI_240& = 240
Public Const MF_SCAN_DPI_300& = 300
Public Const MF_SCAN_DPI_600& = 600
'/*------------------------------------*/
'/* Scan structure                     */
'/*------------------------------------*/
Public Type MF_SCAN
Rem:'// Scan Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        wImageID(1 To 2) As Byte
        sResolution(1 To 2) As Byte
        bAddInfoDataSize As Byte
        pAddInfoData(1 To 4) As Byte
        
        bStatus As Byte
        bDetail As Byte
        dwXSize(1 To 4) As Byte
        dwYSize(1 To 4) As Byte
        dwScanSize(1 To 4) As Byte
        lpbScanData(1 To 4) As Byte
End Type

'/*============================*/
'/* MICR parameters                                        */
'/*============================*/
'/*------------------------------------*/
'/* Structure version(for iVersion)    */
'/*------------------------------------*/
Public Const MF_MICR_VERSION& = &H100
Public Const MF_MICR_VERSION01& = &H101
'/*------------------------------------*/
'/* MICR type(for bMicOcrSelect)       */
'/*------------------------------------*/
Public Const MF_MICR_USE_MICR& = &H1
Public Const MF_MICR_USE_OCR& = &H2
'/*------------------------------------*/
'/* Font(for bFont)                    */
'/*------------------------------------*/
Public Const MF_MICR_FONT_E13B& = 0
Public Const MF_MICR_FONT_CMC7& = 1

Public Const MF_MICR_CHAR_MAX& = 81
Public Const MF_MICR_CHAR_LEN& = 80
'/*------------------------------------*/
'/* Reliability structure              */
'/*------------------------------------*/
Public Type MF_OCR_RELIABILITY
        cRecogChar As Byte                ' Recognized character
        lPercentage(1 To 4) As Byte       ' Reliability(%)
End Type
'/*------------------------------------*/
'/* Reliability information structure  */
'/*------------------------------------*/
Public Type MF_OCR_RELIABLE_INFO
        lPosition(1 To 4) As Byte               ' Position(0 is left edge)
        stFirstSelect As MF_OCR_RELIABILITY     ' First recognition candidate
        stSecondSelect As MF_OCR_RELIABILITY    ' Second recognition candidate
End Type
'/*------------------------------------*/
'/* MICR/OCR structure(Version& = &H0100) */
'/*------------------------------------*/
Public Type MF_MICR01
Rem:'// MIC_OCR Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        bFont As Byte
        bMicOcrSelect As Byte
        blParsing(1 To 4) As Byte

        bStatus As Byte
        bDetail As Byte
        szMicrStr(1 To MF_MICR_CHAR_MAX) As Byte
        stOcrReliableInfo(1 To MF_MICR_CHAR_MAX) As MF_OCR_RELIABLE_INFO
        szAccountNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szAmount(1 To MF_MICR_CHAR_MAX) As Byte
        szBankNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szSerialNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szEPC(1 To MF_MICR_CHAR_MAX) As Byte
        szTransitNumber(1 To MF_MICR_CHAR_MAX) As Byte
        lCheckType(1 To 4) As Byte
        lCountryCode(1 To 4) As Byte
        szOnUSField(1 To MF_MICR_CHAR_MAX) As Byte
        szAuxiliatyOnUsField(1 To MF_MICR_CHAR_MAX) As Byte
End Type
'/*------------------------------------*/
'/* MICR/OCR structure(OLD:Version& = &H0100)*/
'/*------------------------------------*/
Public Type MF_MICR
Rem:'// MIC_OCR Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        bFont As Byte
        bMicOcrSelect As Byte
        blParsing(1 To 4) As Byte

        bStatus As Byte
        bDetail As Byte
        szMicrStr(1 To MF_MICR_CHAR_MAX) As Byte
        stOcrReliableInfo(1 To MF_MICR_CHAR_MAX) As MF_OCR_RELIABLE_INFO
        szAccountNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szAmount(1 To MF_MICR_CHAR_MAX) As Byte
        szBankNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szSerialNumber(1 To MF_MICR_CHAR_MAX) As Byte
        szEPC(1 To MF_MICR_CHAR_MAX) As Byte
        szTransitNumber(1 To MF_MICR_CHAR_MAX) As Byte
        lCheckType(1 To 4) As Byte
        lCountryCode(1 To 4) As Byte
End Type
'/*============================*/
'/* OCR_AB parameters                                      */
'/*============================*/
'/*------------------------------------*/
'/* Structure version(for iVersion)    */
'/*------------------------------------*/
Public Const MF_OCR_AB_VERSION& = &H100
'/*------------------------------------*/
'/* Ocr Type                           */
'/*------------------------------------*/
Public Const MF_OCR_FONT_OCRA_NUM& = 1
Public Const MF_OCR_FONT_OCRA_ALPHA& = 2
Public Const MF_OCR_FONT_OCRA_ALPHANUM& = 3
Public Const MF_OCR_FONT_OCRA_ALPHANUM_WOOH& = 7
Public Const MF_OCR_FONT_OCRA_ALPHANUM_WOZERO& = 11
Public Const MF_OCR_FONT_OCRB_NUM& = 17
Public Const MF_OCR_FONT_OCRB_ALPHA& = 18
Public Const MF_OCR_FONT_OCRB_ALPHANUM& = 19
Public Const MF_OCR_FONT_OCRB_ALPHANUM_WOOH& = 23
Public Const MF_OCR_FONT_OCRB_ALPHANUM_WOZERO& = 27
Public Const MF_OCR_FONT_OCRA_SYMNUM& = 33
Public Const MF_OCR_FONT_OCRB_SYMNUM& = 49
'/*------------------------------------*/
'/* Direction                          */
'/*------------------------------------*/
Public Const MF_OCR_LEFTRIGHT& = 1
Public Const MF_OCR_TOPBOTTOM& = 2
Public Const MF_OCR_RIGHTLEFT& = 3
Public Const MF_OCR_BOTTOMTOP& = 4
'/*------------------------------------*/
'/* Area(for bEndX, bEndY)             */
'/*------------------------------------*/
Public Const OCR_AREA_RIGHT& = 65535
Public Const OCR_AREA_BOTTOM& = 65535
Public Const OCR_AREA_TOP& = 65535
Public Const OCR_AREA_LEFT& = 65535
'/*------------------------------------*/
'/* SpeceHandling(for bSpeceHandling)  */
'/*------------------------------------*/
Public Const OCR_SPACE_ENABLE& = 1
Public Const OCR_SPACE_DISABLE& = 0

Public Const MF_OCR_AB_CHAR_MAX& = 128
'/*------------------------------------*/
'/* OCR AB structure                   */
'/*------------------------------------*/
Public Type MF_OCR_AB
    iSize(1 To 4) As Byte
    iVersion(1 To 4) As Byte
    iRet(1 To 4) As Byte
    bOcrType As Byte
    bDirection As Byte
    wStartX(1 To 2) As Byte
    wStartY(1 To 2) As Byte
    wEndX(1 To 2) As Byte
    wEndY(1 To 2) As Byte
    bSpaceHandling As Byte
    szOcrStr(1 To MF_OCR_AB_CHAR_MAX) As Byte
    stOcrReliableInfo(1 To MF_OCR_AB_CHAR_MAX) As MF_OCR_RELIABLE_INFO
End Type

'/*============================*/
'/* Process parameters                                     */
'/*============================*/
'/*------------------------------------*/
'/* Structure version(for iVersion)    */
'/*------------------------------------*/
Public Const MF_PROCESS_VERSION& = &H100
Public Const MF_PROCESS_VERSION01& = &H101
'/*------------------------------------*/
'/* Activation mode(For bActivationMode) */
'/*------------------------------------*/
Public Const MF_ACTIVATE_MODE_CONFIRMATION& = 0
Public Const MF_ACTIVATE_MODE_HIGH_SPEED& = 1
'/*------------------------------------*/
'/* Paper type(For bPaperType)         */
'/*------------------------------------*/
Public Const MF_PAPER_TYPE_OTHER& = 0
Public Const MF_PAPER_TYPE_CHECK& = 1
'/*------------------------------------*/
'/* Stamp status(For bSuccessStamp, bPaperMisInsertionStamp, bNoiseStamp */
'/*              , bDoubleFeedStamp, bBaddataStamp, bNodataStamp)        */
'/*------------------------------------*/
Public Const MF_STAMP_DISABLE& = 0
Public Const MF_STAMP_ENABLE& = 1
'/*------------------------------------*/
'/* Error detect(For bPaperMisInsertionErrorSelect, bNoiseErrorSelect               */
'/*              , bDoubleFeedErrorSelect, bBaddataErrorSelect, bNodataErrorSelect) */
'/*------------------------------------*/
Public Const MF_ERROR_SELECT_NODETECT& = 0
Public Const MF_ERROR_SELECT_DETECT& = 1
'/*------------------------------------*/
'/* Eject select(For bPaperMisInsertionErrorEject, bNoiseErrorEject              */
'/*              , bDoubleFeedErrorEject, bBaddataErrorEject, bNodataErrorEject) */
'/*------------------------------------*/
Public Const MF_EJECT_MAIN_POCKET& = &H22
Public Const MF_EJECT_SUB_POCKET& = &H24
Public Const MF_EJECT_NOEJECT& = &H28
'/*------------------------------------*/
'/* Cancel status(For bPaperMisInsertionCancel, bNoiseCancel, bDoubleFeedCancel */
'/*              , bBaddataCancel, bNodataCancel)                               */
'/*------------------------------------*/
Public Const MF_CANCEL_DISABLE& = 0
Public Const MF_CANCEL_ENABLE& = 1
'/*------------------------------------*/
'/* Nearfull parmit(For bNearFullSelect) */
'/*------------------------------------*/
Public Const MF_NEARFULL_NOT_PERMIT& = &H0
Public Const MF_NEARFULL_MAIN_PERMIT& = &H1
Public Const MF_NEARFULL_SUB_PERMIT& = &H2
Public Const MF_NEARFULL_PERMIT& = &H3
'/*------------------------------------*/
'/* Result partial(For bResultPartialData) */
'/*------------------------------------*/
Public Const MF_RESULT_NONE& = 0
Public Const MF_RESULT_PARTIAL& = 1
'/*------------------------------------*/
'/* Endorse Print Mode(For bEndorsePrintMode) */
'/*------------------------------------*/
Public Const MF_ENDORSEPRINT_MODE_HIGHSPEED& = 0
Public Const MF_ENDORSEPRINT_MODE_DATAWAITING& = 1
'/*------------------------------------*/
'/* Process structure(Version& = &H0100)  */
'/*------------------------------------*/
Public Type MF_PROCESS01
Rem:'// Process Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        bActivationMode As Byte
        bPaperType As Byte
        dwStartWaitTime(1 To 4) As Byte
        bSuccessStamp As Byte
        bPaperMisInsertionErrorSelect As Byte
        bPaperMisInsertionErrorEject As Byte
        bPaperMisInsertionStamp As Byte
        bPaperMisInsertionCancel As Byte
        bNoiseErrorSelect As Byte
        bNoiseErrorEject As Byte
        bNoiseStamp As Byte
        bNoiseCancel As Byte
        bDoubleFeedErrorSelect As Byte
        bDoubleFeedErrorEject As Byte
        bDoubleFeedStamp As Byte
        bDoubleFeedCancel As Byte
        bBaddataErrorSelect As Byte
        bBaddataCount As Byte
        bBaddataErrorEject As Byte
        bBaddataStamp As Byte
        bBaddataCancel As Byte
        bNodataErrorSelect As Byte
        bNodataErrorEject As Byte
        bNodataStamp As Byte
        bNodataCancel As Byte
        bNearFullSelect As Byte
        bResultPartialData As Byte
        bEndorsePrintMode As Byte
        bPrnDataLenExceedErrorEject As Byte
        bPrnDataLenExceedCancel As Byte
        bPrnDataUnreceiveErrorEject As Byte
        bPrnDataUnreceiveCancel As Byte
End Type
'/*------------------------------------*/
'/* Process structure(OLD:Version& = &H0100)*/
'/*------------------------------------*/
Public Type MF_PROCESS
Rem:'// Process Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        bActivationMode As Byte
        bPaperType As Byte
        dwStartWaitTime(1 To 4) As Byte
        bSuccessStamp As Byte
        bPaperMisInsertionErrorSelect As Byte
        bPaperMisInsertionErrorEject As Byte
        bPaperMisInsertionStamp As Byte
        bPaperMisInsertionCancel As Byte
        bNoiseErrorSelect As Byte
        bNoiseErrorEject As Byte
        bNoiseStamp As Byte
        bNoiseCancel As Byte
        bDoubleFeedErrorSelect As Byte
        bDoubleFeedErrorEject As Byte
        bDoubleFeedStamp As Byte
        bDoubleFeedCancel As Byte
        bBaddataErrorSelect As Byte
        bBaddataCount As Byte
        bBaddataErrorEject As Byte
        bBaddataStamp As Byte
        bBaddataCancel As Byte
        bNodataErrorSelect As Byte
        bNodataErrorEject As Byte
        bNodataStamp As Byte
        bNodataCancel As Byte
        bNearFullSelect As Byte
        bResultPartialData As Byte
End Type

'/*============================*/
'/* Print parameters                                       */
'/*============================*/
'/*------------------------------------*/
'/* Structure version(for iVersion)    */
'/*------------------------------------*/
Public Const MF_PRINT_VERSION01& = &H101
Public Const MF_PRINT_VERSION& = &H100
'/*------------------------------------*/
'/* Line number(for lpString,dwAttribute,wFont and wfontSize) */
'/*------------------------------------*/
Public Const MF_PRINT_LINE_1& = 0
Public Const MF_PRINT_LINE_2& = 1
Public Const MF_PRINT_LINE_3& = 2
Public Const MF_PRINT_LINE_MAX& = MF_PRINT_LINE_3
'/*------------------------------------*/
'/* Charactor attribute(for dwAttribute) */
'/*------------------------------------*/
Public Const MF_PRINT_NO_ATTRIBUTE& = &H0
Public Const MF_PRINT_BOLD& = &H1
Public Const MF_PRINT_UNDERLINE_1& = &H10
Public Const MF_PRINT_UNDERLINE_2& = &H20
Public Const MF_PRINT_BLACK& = &H100
Public Const MF_PRINT_1ST_COLOR& = &H100
Public Const MF_PRINT_COLOR& = &H200
Public Const MF_PRINT_2ND_COLOR& = &H200
Public Const MF_PRINT_MIXED& = &H300
Public Const MF_PRINT_REVERSEVIDEO& = &H1000
'/*------------------------------------*/
'/* Font type(for wFont)               */
'/*------------------------------------*/
Public Const MF_PRINT_FONT_A& = 1
Public Const MF_PRINT_FONT_B& = 2
Public Const MF_PRINT_SYSTEMFONT& = 3
'/*------------------------------------*/
'/* Font size(for wFontSize)           */
'/*------------------------------------*/
Public Const MF_PRINT_FONT_W1_H1& = &H11
Public Const MF_PRINT_FONT_W1_H2& = &H12
Public Const MF_PRINT_FONT_W2_H1& = &H21
Public Const MF_PRINT_FONT_W2_H2& = &H22
'/*------------------------------------*/
'/* Printing speed(for bSpeed)         */
'/*------------------------------------*/
Public Const MF_PRINT_SPEED_NORMAL& = 0
Public Const MF_PRINT_SPEED_HIGH& = 1
Public Const MF_PRINT_SPEED_ECONOMY& = 2
'/*------------------------------------*/
'/* PrintDirection(for bDirection)     */
'/*------------------------------------*/
Public Const MF_PRINT_DIRECTION_DOUBLE& = 0
Public Const MF_PRINT_DIRECTION_SINGLE& = 1
Public Const MF_PRINT_DERECTION_DOUBLE& = 0
Public Const MF_PRINT_DERECTION_SINGLE& = 1
'/*------------------------------------*/
'/* Endorse type                       */
'/*------------------------------------*/
Public Const MF_PRINT_TYPE_ENDORSE_ONLY& = 0
Public Const MF_PRINT_TYPE_ENDORSE_NORMAL& = 1
Public Const MF_PRINT_TYPE_ELECTRIC_ENDORSE_ONLY& = 2
Public Const MF_PRINT_TYPE_ENDORSE_EXTEND& = 3
Public Const MF_PRINT_TYPE_ELECTRIC_ENDORSE_EXTEND& = 4
'/*------------------------------------*/
'/* print structure(version& = &H0101)    */
'/*------------------------------------*/
Public Type MF_PRINT01
Rem:'// Print Section
        iSize(1 To 4) As Byte
        iVersion(1 To 4) As Byte
        iRet(1 To 4) As Byte
        blDummy(1 To 4) As Byte
        lpString(1 To 12) As Byte
        dwAttribute(1 To 12) As Byte
        wFont(1 To 6) As Byte
        wFontSize(1 To 6) As Byte
        bSpeed As Byte
        bDirection(1 To 4) As Byte
        dwEndorseType(1 To 4) As Byte
End Type
'/*------------------------------------*/
'/* print structure(OLD:version& = &H0100)*/
'/*------------------------------------*/
Public Type MF_PRINT
Rem:'// Print Section
        iSize As Long
        iVersion As Long
        iRet As Long
        blElectricEndorse As Boolean
        lpString(3) As Object
        dwAttribute(3) As Long
        wFont(3) As Integer
        wFontSize(3) As Integer
        bSpeed As Byte
        bDirection As Boolean
End Type

'/*============================*/
'/* IQA parameters                                         */
'/*============================*/
'/*------------------------------------*/
'/* Structure version(for iVersion)    */
'/*------------------------------------*/
Public Const MF_IQA_VERSION& = &H100
'/*------------------------------------*/
'/* IQA test status(For bUndersize,bOversize,bMincompressed,bMaxcompressed,    */
'/*                     bFront_rear,bToolight,bToodark,bStreaks,bNoise,bFocus, */
'/*                     bCorners,bEdges,bFraming,bSkew,bCarbon,bPiggyback)     */
'/*------------------------------------*/
Public Const MF_IQA_TEST_DISABLE& = 0
Public Const MF_IQA_TEST_ENABLE& = 1
'/*------------------------------------*/
'/* IQA structure                      */
'/*------------------------------------*/
Public Type MF_IQA
Rem:'// IQA Section
    iSize(1 To 4) As Byte
    iVersion(1 To 4) As Byte
    bErrorSelect As Byte
    bErrorEject As Byte
    bStamp As Byte
    bCancel As Byte

    bImageFormat As Byte
    bColorDepth As Byte
    bThreshold As Byte
    bColor As Byte
    bExOption As Byte
    sResolution(1 To 2) As Byte

    bUndersize As Byte
    bOversize As Byte
    bMincompressed As Byte
    bMaxcompressed As Byte
    bFront_rear As Byte
    bToolight As Byte
    bToodark As Byte
    bStreaks As Byte
    bNoise As Byte
    bFocus As Byte
    bCorners As Byte
    bEdges As Byte
    bFraming As Byte
    bSkew As Byte
    bCarbon As Byte
    bPiggyback As Byte
End Type

'/*============================*/
'/* IQA result parameters                                  */
'/*============================*/
'/*------------------------------------*/
'/* Structure version(for iVersion)    */
'/*------------------------------------*/
Public Const MF_IQARESULT_VERSION& = &H100
'/*------------------------------------*/
'/* IQA result value                   */
'/*------------------------------------*/
Public Const IQARESULT_NOT_TESTED& = 0
Public Const IQARESULT_PASS& = 1
Public Const IQARESULT_NOT_PASS& = 2

Rem:'// UndersizeImage structure
Public Type IQARESULT_UNDERSIZE_IMAGE
    bResult As Byte
    iWidth(1 To 4) As Byte             ''// width in tenths of inches
    iHeight(1 To 4) As Byte            ''// height in tenths of inches
End Type

Rem:'// OversizeImage structure
Public Type IQARESULT_OVERSIZE_IMAGE
    bResult As Byte
    iWidth(1 To 4) As Byte             ''// width in tenths of inches
    iHeight(1 To 4) As Byte            ''// height in tenths of inches
End Type

Rem:'// MinCompressedImageSize structure
Public Type IQARESULT_MIN_COMPRESSED_IMAGE_SIZE
    bResult As Byte
    iSize(1 To 4) As Byte              ''// compressed image size in bytes
End Type

Rem:'// MaxCompressedImageSize structure
Public Type IQARESULT_MAX_COMPRESSED_IMAGE_SIZE
    bResult As Byte
    iSize(1 To 4) As Byte              ''// compressed image size in bytes
End Type

Rem:'// FrontRearImageMismatch structure
Public Type IQARESULT_FRONT_REAR_IMAGE_MISMATCH
    bResult As Byte
    iAbsWidthDiff(1 To 4) As Byte      ''// absolute value of width difference between front and rear in tenths of inches
    iAbsHeightDiff(1 To 4) As Byte     ''// absolute value of height difference between front and rear in tenths of inches
End Type

Rem:'// ImageTooLight structure
Public Type IQARESULT_IMAGE_TOO_LIGHT
    bResult As Byte
    iBlackPixels(1 To 4) As Byte       ''// percenage of black pixels in the image in units of 0.1 percent
    iBrightness(1 To 4) As Byte        ''// percent image brightness in units of 0.1 percent
    iContrast(1 To 4) As Byte          ''// percent image contrast in units of 0.1 percent
End Type

Rem:'// ImageTooDark structure
Public Type IQARESULT_IMAGE_TOO_DARK
    bResult As Byte
    iBlackPixels(1 To 4) As Byte       ''// percenage of black pixels in the image in units of 0.1 percent
    iBrightness(1 To 4) As Byte        ''// percent image brightness in units of 0.1 percent
End Type

Rem:'// HorizontalStreaksPresent structure
Public Type IQARESULT_HORIZONTAL_STREAKS_PRESENT
    bResult As Byte
    iStreakCount(1 To 4) As Byte       ''// Number of black streaks present in bitonal images
    iStreakHeight(1 To 4) As Byte      ''// Height of the largest horizontal black streak
End Type

Rem:'// ExcessiveSpotNoise structure
Public Type IQARESULT_EXCESSIVE_SPOT_NOISE
    bResult As Byte
    iCount(1 To 4) As Byte             ''// average number of spot per square inch of the image defined for bi-tonal only
End Type

Rem:'// ImageOutOfFocus structure
Public Type IQARESULT_IMAGE_OUT_OF_FOCUS
    bResult As Byte
    iImageFocusScore(1 To 4) As Byte   ''// (max video gradient) / (grey level dynamic range) * (pixel pitch)
End Type

Rem:'// FoldedTornDocCorners structure
Public Type IQARESULT_FOLDED_TORN_DOC_CORNERS
    bResult As Byte
    iTopLeftWidth(1 To 4) As Byte
    iTopLeftHeight(1 To 4) As Byte
    iTopRightWidth(1 To 4) As Byte
    iTopRightHeight(1 To 4) As Byte
    iBottomLeftWidth(1 To 4) As Byte
    iBottomLeftHeight(1 To 4) As Byte
    iBottomRightWidth(1 To 4) As Byte
    iBottomRightHeight(1 To 4) As Byte
End Type

Rem:'// FoldedTornDocEdges structure
Public Type IQARESULT_FOLDED_TORN_DOC_EDGES
    bResult As Byte
    iTopWidth(1 To 4) As Byte
    iTopHeight(1 To 4) As Byte
    iLeftWidth(1 To 4) As Byte
    iLeftHeight(1 To 4) As Byte
    iRightWidth(1 To 4) As Byte
    iRightHeight(1 To 4) As Byte
    iBottomWidth(1 To 4) As Byte
    iBottomHeight(1 To 4) As Byte
End Type

Rem:'// DocFramingError structure
Public Type IQARESULT_DOC_FRAMING_ERROR
    bResult As Byte
    iTop(1 To 4) As Byte
    iLeft(1 To 4) As Byte
    iRight(1 To 4) As Byte
    iBottom(1 To 4) As Byte
End Type

Rem:'// ExcessiveDocSkew structure
Public Type IQARESULT_EXCESSIVE_DOC_SKEW
    bResult As Byte
    iAngle(1 To 4) As Byte
    iRange(1 To 4) As Byte
End Type

Rem:'// CarbonStripDetection structure
Public Type IQARESULT_CARBON_STRIP_DETECTION
    bResult As Byte
    iStripHeight(1 To 4) As Byte
End Type

Rem:'// Piggyback structure
Public Type IQARESULT_PIGGYBACK
    bResult As Byte
End Type

'/*------------------------------------*/
'/* IQA result structure               */
'/*------------------------------------*/
Public Type MF_IQA_RESULT
    iSize(1 To 4) As Byte
    iVersion(1 To 4) As Byte
    iRet(1 To 4) As Byte

    stUnderSize As IQARESULT_UNDERSIZE_IMAGE
    stOverSize As IQARESULT_OVERSIZE_IMAGE
    stMinCompressedImageSize As IQARESULT_MIN_COMPRESSED_IMAGE_SIZE
    stMaxCompressedImageSize As IQARESULT_MAX_COMPRESSED_IMAGE_SIZE
    stFrontRearImageMismatch As IQARESULT_FRONT_REAR_IMAGE_MISMATCH
    stImageTooLight As IQARESULT_IMAGE_TOO_LIGHT
    stImageTooDark As IQARESULT_IMAGE_TOO_DARK
    stHorizontalStreaksPresent As IQARESULT_HORIZONTAL_STREAKS_PRESENT
    stExcessiveSpotNoise As IQARESULT_EXCESSIVE_SPOT_NOISE
    stImageOutOfFocus As IQARESULT_IMAGE_OUT_OF_FOCUS
    stFoldedTornDocCorners As IQARESULT_FOLDED_TORN_DOC_CORNERS
    stFoldedTornDocEdges As IQARESULT_FOLDED_TORN_DOC_EDGES
    stDocFramingError As IQARESULT_DOC_FRAMING_ERROR
    stExcessiveDocSkew As IQARESULT_EXCESSIVE_DOC_SKEW
    stCarbonStripDetection As IQARESULT_CARBON_STRIP_DETECTION
    stPiggyback As IQARESULT_PIGGYBACK
End Type

'/*============================*/
'/* Barcode parameters                                     */
'/*============================*/
'/*------------------------------------*/
'/* Structure version(for iVersion)    */
'/*------------------------------------*/
Public Const MF_BARCODE_VERSION& = &H100
'/*------------------------------------*/
'/* Barcode symbol                     */
'/*------------------------------------*/
Public Const MF_BARCODE_SYMBOL_CODABAR& = &H1
Public Const MF_BARCODE_SYMBOL_CODE128& = &H2
Public Const MF_BARCODE_SYMBOL_CODE39& = &H4
Public Const MF_BARCODE_SYMBOL_ITF& = &H8
Public Const MF_BARCODE_SYMBOL_EAN_JAN& = &H10
Public Const MF_BARCODE_SYMBOL_UPC_A& = &H20
Public Const MF_BARCODE_SYMBOL_UPC_E& = &H40
'/*------------------------------------*/
'/* Barcode direction                  */
'/*------------------------------------*/
Public Const MF_BARCODE_DIRECTION_ALL& = 0
Public Const MF_BARCODE_DIRECTION_LEFTRIGHT& = 1
Public Const MF_BARCODE_DIRECTION_TOPBOTTOM& = 2
Public Const MF_BARCODE_DIRECTION_RIGHTLEFT& = 3
Public Const MF_BARCODE_DIRECTION_BOTTOMTOP& = 4
'/*------------------------------------*/
'/* Barcode area origin                */
'/*------------------------------------*/
Public Const MF_BARCODE_ORIGIN_TOP_LEFT& = 0
Public Const MF_BARCODE_ORIGIN_BOTTOM_LEFT& = 1
Public Const MF_BARCODE_ORIGIN_TOP_RIGHT& = 2
Public Const MF_BARCODE_ORIGIN_BOTTOM_RIGHT& = 3
'/*------------------------------------*/
'/* Barcode color                      */
'/*------------------------------------*/
Public Const MF_BARCODE_TARGET_COLOR_GRAY& = 0
Public Const MF_BARCODE_TARGET_COLOR_RED& = 1
Public Const MF_BARCODE_TARGET_COLOR_GREEN& = 2
Public Const MF_BARCODE_TARGET_COLOR_BLUE& = 3
Public Const MF_BARCODE_TARGET_COLOR_UV& = 4
'/*------------------------------------*/
'/* Area(for wEndX, wEndY)             */
'/*------------------------------------*/
Public Const MF_BARCODE_AREA_RIGHT& = 65535
Public Const MF_BARCODE_AREA_BOTTOM& = 65535
'/*------------------------------------*/
'/* Barcode data                       */
'/*------------------------------------*/
Public Type BARCODE_DATA
    dwSymbol(1 To 4) As Byte
    bDirection As Byte
    wStartX(1 To 2) As Byte
    wStartY(1 To 2) As Byte
    wEndX(1 To 2) As Byte
    wEndY(1 To 2) As Byte
    dwDataSize(1 To 4) As Byte     ' data length
    pData(1 To 4) As Byte          ' barcode data(binary)
End Type
'/*------------------------------------*/
'/* Barcode decode information         */
'/*------------------------------------*/
Public Type BARCODE_INFO
    iRet(1 To 4) As Byte
    bStatus As Byte
    bDetail As Byte
    dwSymbolMask(1 To 4) As Byte
    bDirection As Byte
    bOrigin As Byte
    wStartX(1 To 2) As Byte
    wStartY(1 To 2) As Byte
    wEndX(1 To 2) As Byte
    wEndY(1 To 2) As Byte
End Type
'/*------------------------------------*/
'/* Barcode structure                  */
'/*------------------------------------*/
Public Type MF_BARCODE
Rem:'// Barcode Section
    iSize(1 To 4) As Byte
    iVersion(1 To 4) As Byte
    iRet(1 To 4) As Byte

    bErrorSelect As Byte
    bErrorEject As Byte
    bStamp As Byte
    bCancel As Byte

    dwTargetColor(1 To 4) As Byte
    sResolution(1 To 2) As Byte
    dwInfoMode(1 To 4) As Byte
    stInfo(1 To 5) As BARCODE_INFO
    bDataCount As Byte         ' array size for lpData
    lpData(1 To 4) As Byte     ' array of BARCODE_DATA
End Type

'/*============================*/
'/* VERSION_INFO parameters                                */
'/*============================*/
Public Const VERSION_CHAR_MAX& = 64
'/*------------------------------------*/
'/* Version info structure             */
'/*------------------------------------*/
Public Type VERSION_INFO
    lpszDescription(1 To VERSION_CHAR_MAX) As Byte
    lpszVersion(1 To VERSION_CHAR_MAX) As Byte
End Type

'/*============================*/
'/* DECORATE parameters                                    */
'/*============================*/
'/*------------------------------------*/
'/* Decorate structure                 */
'/*------------------------------------*/
Public Type mf_Decorate
    dwAttribute(1 To 4) As Byte
    wFont(1 To 2) As Byte
    szFontName(1 To 4) As Byte
    wFontSize(1 To 2) As Byte
End Type

'/*============================*/
'/* Print Area Info parameters                             */
'/*============================*/
'/*------------------------------------*/
'/* Print Area Info structure          */
'/*------------------------------------*/
Public Type PRINTAREAINFO
    szAreaName(1 To 128) As Byte
    nOriginX(1 To 4) As Byte
    nOriginY(1 To 4) As Byte
    nWidth(1 To 4) As Byte
    nHeight(1 To 4) As Byte
    inRotate(1 To 4) As Byte
End Type

'#if defined(WIN32)
'#pragma pack(pop)    '/* pop structure packing back to previous state */
'#End If

'#End If '/* !defined(_MULTI_FUNCTION_H) */

