Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms

Namespace TM_S9000Sample
	Public Partial Class ConfigureForm
		Inherits Form
		Private m_objConfigData As StructByStep = Nothing

		Public Sub New()
			InitializeComponent()

			m_objConfigData = New StructByStep()
		End Sub

		Private Sub ConfigureForm_Load(sender As Object, e As EventArgs)
			LoadResourceString()

			SetControlData()

			UpdateControls()
		End Sub

		Public Sub SetConfigData(objConfigData As StructByStep)
			m_objConfigData.Copy(objConfigData)
		End Sub

		Public Sub GetConfigData(ByRef objConfigData As StructByStep)
			If objConfigData IsNot Nothing Then
				objConfigData.Copy(m_objConfigData)
			End If
		End Sub

		Private Sub LoadResourceString()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			btnOK.Text = ConstComStr.STR_CONFIGDLG_BUTTON_OK
			btnCancel.Text = ConstComStr.STR_CONFIGDLG_BUTTON_CANCEL

			stGroupScanning.Text = ConstComStr.STR_CONFIGDLG_GROUP_SCANNING
			stGroupScanningMedia.Text = ConstComStr.STR_CONFIGDLG_GROUP_SCANNINGMEDIA
			stGroupImageChannel.Text = ConstComStr.STR_CONFIGDLG_GROUP_IMAGECHANNEL
			stGroupRGBColorDepth.Text = ConstComStr.STR_CONFIGDLG_GROUP_RGBCOLORDEPTH
			stGroupIRColorDepth.Text = ConstComStr.STR_CONFIGDLG_GROUP_IRCOLORDEPTH

			stResolution.Text = ConstComStr.STR_CONFIGDLG_STATIC_RESOLUTION

			btnRadioSMCheckPaper.Text = ConstComStr.STR_CONFIGDLG_RADIO_SM_CHECKPAPER
			btnRadioSMCard.Text = ConstComStr.STR_CONFIGDLG_RADIO_SM_CARD
			btnRadioICRGB.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGB
			btnRadioICIR.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_IR
			btnRadioICRGBIR.Text = ConstComStr.STR_CONFIGDLG_RADIO_IC_RGBIR
			btnRadioCDRColor.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_COLOR
			btnRadioCDRGray.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_GRAY
			btnRadioCDRBW.Text = ConstComStr.STR_CONFIGDLG_RADIO_RGBCD_BW
			btnRadioCDIGray.Text = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_GRAY
			btnRadioCDIBW.Text = ConstComStr.STR_CONFIGDLG_RADIO_IRCD_BW
			btnCheckSCSave.Text = ConstComStr.STR_CONFIGDLG_CHECK_SC_SAVEFILE

			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120)
			cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100)


			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			stGroupMICR.Text = ConstComStr.STR_CONFIGDLG_GROUP_MICR
			stGroupMICRFont.Text = ConstComStr.STR_CONFIGDLG_GROUP_MICRFONT

			btnRadioMFE13B.Text = ConstComStr.STR_CONFIGDLG_RADIO_MF_E13B
			btnRadioMFCMC7.Text = ConstComStr.STR_CONFIGDLG_RADIO_MF_CMC7

			btnCheckMIClearSpace.Text = ConstComStr.STR_CONFIGDLG_CHECK_MI_CLEARSPACE
			btnCheckMISaveFile.Text = ConstComStr.STR_CONFIGDLG_CHECK_MI_SAVEFILE


			'''/////////////
			'''/ Step 4 ////
			'''/////////////

			stGroupEndorsement.Text = ConstComStr.STR_CONFIGDLG_GROUP_ENDORSEMENT
			stGroupPrintType.Text = ConstComStr.STR_CONFIGDLG_GROUP_PRINTTYPE
			stGroupPrintMode.Text = ConstComStr.STR_CONFIGDLG_GROUP_PRINTMODE

			btnRadioPTPhysical.Text = ConstComStr.STR_CONFIGDLG_RADIO_PT_PHYSICAL
			btnRadioPTElectronic.Text = ConstComStr.STR_CONFIGDLG_RADIO_PT_ELECTRONIC
			btnRadioPMHighSpeed.Text = ConstComStr.STR_CONFIGDLG_RADIO_PT_HIGHSPEEDMODE
			btnRadioPMDataWaiting.Text = ConstComStr.STR_CONFIGDLG_RADIO_PT_DATAWAITINGMODE

			btnCheckENPrintText.Text = ConstComStr.STR_CONFIGDLG_CHECK_EN_PRINTTEXT
			btnCheckENPrintImage.Text = ConstComStr.STR_CONFIGDLG_CHECK_EN_PRINTIMAGE
			btnCheckENPrnDataReceiveCancel.Text = ConstComStr.STR_CONFIGDLG_CHECK_EN_PRNDATAUNRECEIVECANCEL

		End Sub

		Private Sub SetControlData()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////
			Select Case m_objConfigData.nRadio_ScanningMedia
				Case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER
					btnRadioSMCheckPaper.Checked = True
					btnRadioSMCard.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD
					btnRadioSMCheckPaper.Checked = False
					btnRadioSMCard.Checked = True
					Exit Select
				Case Else
					Exit Select
			End Select

			Select Case m_objConfigData.nRadio_ImageChannel
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB
					btnRadioICRGB.Checked = True
					btnRadioICIR.Checked = False
					btnRadioICRGBIR.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR
					btnRadioICRGB.Checked = False
					btnRadioICIR.Checked = True
					btnRadioICRGBIR.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR
					btnRadioICRGB.Checked = False
					btnRadioICIR.Checked = False
					btnRadioICRGBIR.Checked = True
					Exit Select
				Case Else
					Exit Select
			End Select
			Select Case m_objConfigData.nRadio_RGBColorDepth
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR
					btnRadioCDRColor.Checked = True
					btnRadioCDRGray.Checked = False
					btnRadioCDRBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY
					btnRadioCDRColor.Checked = False
					btnRadioCDRGray.Checked = True
					btnRadioCDRBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW
					btnRadioCDRColor.Checked = False
					btnRadioCDRGray.Checked = False
					btnRadioCDRBW.Checked = True
					Exit Select
				Case Else
					Exit Select
			End Select
			Select Case m_objConfigData.nRadio_IRColorDepth
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY
					btnRadioCDIGray.Checked = True
					btnRadioCDIBW.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW
					btnRadioCDIGray.Checked = False
					btnRadioCDIBW.Checked = True
					Exit Select
				Case Else
					Exit Select
			End Select

			btnCheckSCSave.Checked = m_objConfigData.bCheck_Scan_SaveFile
			cmbResolution.SelectedIndex = m_objConfigData.nCombo_Resolution


			'''/////////////
			'''/ Step 3 ////
			'''/////////////
			Select Case m_objConfigData.nRadio_MICRFont
				Case ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B
					btnRadioMFE13B.Checked = True
					btnRadioMFCMC7.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_MF_CMC7
					btnRadioMFE13B.Checked = False
					btnRadioMFCMC7.Checked = True
					Exit Select
				Case Else
					Exit Select
			End Select

			btnCheckMIClearSpace.Checked = m_objConfigData.bCheck_MICR_ClearSpace
			btnCheckMISaveFile.Checked = m_objConfigData.bCheck_MICR_SaveFile


			'''/////////////
			'''/ Step 4 ////
			'''/////////////
			Select Case m_objConfigData.nRadio_PrintType
				Case ConstComVal.VAL_CONFIGDLG_RADIO_PT_PHYSICAL
					btnRadioPTPhysical.Checked = True
					btnRadioPTElectronic.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_PT_ELECTRONIC
					btnRadioPTPhysical.Checked = False
					btnRadioPTElectronic.Checked = True
					Exit Select
				Case Else
					Exit Select
			End Select

			Select Case m_objConfigData.nRadio_PrintMode
				Case ConstComVal.VAL_CONFIGDLG_RADIO_PM_HIGHSPEEDMODE
					btnRadioPMHighSpeed.Checked = True
					btnRadioPMDataWaiting.Checked = False
					Exit Select
				Case ConstComVal.VAL_CONFIGDLG_RADIO_PM_DATAWAITINGMODE
					btnRadioPMHighSpeed.Checked = False
					btnRadioPMDataWaiting.Checked = True
					Exit Select
				Case Else
					Exit Select
			End Select

			btnCheckENPrintText.Checked = m_objConfigData.bCheck_Endorsement_PrintText
			btnCheckENPrintImage.Checked = m_objConfigData.bCheck_Endorsement_PrintImage
			btnCheckENPrnDataReceiveCancel.Checked = m_objConfigData.bCheck_Endorsement_PrnDataUnreceiveCancel

		End Sub

		Private Sub GetControlData()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////
			If btnRadioSMCheckPaper.Checked = True Then
				m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CHECKPAPER
			ElseIf btnRadioSMCard.Checked = True Then
				m_objConfigData.nRadio_ScanningMedia = ConstComVal.VAL_CONFIGDLG_RADIO_SM_CARD
			End If

			If btnRadioICRGB.Checked = True Then
				m_objConfigData.nRadio_ImageChannel = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGB
			ElseIf btnRadioICIR.Checked = True Then
				m_objConfigData.nRadio_ImageChannel = ConstComVal.VAL_CONFIGDLG_RADIO_IC_IR
			ElseIf btnRadioICRGBIR.Checked = True Then
				m_objConfigData.nRadio_ImageChannel = ConstComVal.VAL_CONFIGDLG_RADIO_IC_RGBIR
			End If

			If btnRadioCDRColor.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_COLOR
			ElseIf btnRadioCDRGray.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_GRAY
			ElseIf btnRadioCDRBW.Checked = True Then
				m_objConfigData.nRadio_RGBColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_RGBCD_BW
			End If

			If btnRadioCDIGray.Checked = True Then
				m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_GRAY
			ElseIf btnRadioCDIBW.Checked = True Then
				m_objConfigData.nRadio_IRColorDepth = ConstComVal.VAL_CONFIGDLG_RADIO_IRCD_BW
			End If

			m_objConfigData.bCheck_Scan_SaveFile = btnCheckSCSave.Checked
			m_objConfigData.nCombo_Resolution = GetValueResolutionCombobox()

			'''/////////////
			'''/ Step 3 ////
			'''/////////////
			If btnRadioMFE13B.Checked = True Then
				m_objConfigData.nRadio_MICRFont = ConstComVal.VAL_CONFIGDLG_RADIO_MF_E13B
			ElseIf btnRadioMFCMC7.Checked = True Then
				m_objConfigData.nRadio_MICRFont = ConstComVal.VAL_CONFIGDLG_RADIO_MF_CMC7
			End If

			m_objConfigData.bCheck_MICR_ClearSpace = btnCheckMIClearSpace.Checked
			m_objConfigData.bCheck_MICR_SaveFile = btnCheckMISaveFile.Checked

			'''/////////////
			'''/ Step 4 ////
			'''/////////////
			If btnRadioPTPhysical.Checked = True Then
				m_objConfigData.nRadio_PrintType = ConstComVal.VAL_CONFIGDLG_RADIO_PT_PHYSICAL
			ElseIf btnRadioPTElectronic.Checked = True Then
				m_objConfigData.nRadio_PrintType = ConstComVal.VAL_CONFIGDLG_RADIO_PT_ELECTRONIC
			End If

			If btnRadioPMHighSpeed.Checked = True Then
				m_objConfigData.nRadio_PrintMode = ConstComVal.VAL_CONFIGDLG_RADIO_PM_HIGHSPEEDMODE
			ElseIf btnRadioPMDataWaiting.Checked = True Then
				m_objConfigData.nRadio_PrintMode = ConstComVal.VAL_CONFIGDLG_RADIO_PM_DATAWAITINGMODE
			End If

			m_objConfigData.bCheck_Endorsement_PrintText = btnCheckENPrintText.Checked
			m_objConfigData.bCheck_Endorsement_PrintImage = btnCheckENPrintImage.Checked
			m_objConfigData.bCheck_Endorsement_PrnDataUnreceiveCancel = btnCheckENPrnDataReceiveCancel.Checked
		End Sub

		Private Sub UpdateControls()
			'''/////////////
			'''/ Step 2 ////
			'''/////////////

			' ImageChannel
			If btnRadioSMCard.Checked = True Then
				btnRadioICRGBIR.Enabled = False

				If btnRadioICRGBIR.Checked = True Then
					btnRadioICIR.Checked = True
					btnRadioICRGBIR.Checked = False

				End If
			ElseIf btnRadioSMCheckPaper.Checked = True Then
				btnRadioICRGBIR.Enabled = True
			End If

			' RGB ColorDepth Color
			If btnRadioICIR.Checked = True Then
				btnRadioCDRColor.Enabled = False
			Else
				btnRadioCDRColor.Enabled = True
			End If

			' RGB ColorDepth Gray
			If btnRadioICIR.Checked = True Then
				btnRadioCDRGray.Enabled = False
			Else
				btnRadioCDRGray.Enabled = True
			End If

			' RGB ColorDepth B/W
			If btnRadioICIR.Checked = True OrElse btnRadioSMCard.Checked = True Then
				btnRadioCDRBW.Enabled = False
			Else
				btnRadioCDRBW.Enabled = True
			End If

			' IR ColorDepth Gray
			If btnRadioICRGB.Checked = True Then
				btnRadioCDIGray.Enabled = False
			Else
				btnRadioCDIGray.Enabled = True
			End If

			' IR ColorDepth B/W
			If btnRadioICRGB.Checked = True OrElse btnRadioSMCard.Checked = True Then
				btnRadioCDIBW.Enabled = False
			Else
				btnRadioCDIBW.Enabled = True
			End If

			If btnRadioCDRBW.Checked = True AndAlso btnRadioCDRGray.Enabled.Equals(True) AndAlso Not btnRadioCDRBW.Enabled.Equals(True) Then
				btnRadioCDRColor.Checked = False
				btnRadioCDRGray.Checked = True
				btnRadioCDRBW.Checked = False
			End If
			If btnRadioCDIBW.Checked = True AndAlso btnRadioCDIGray.Enabled.Equals(True) AndAlso Not btnRadioCDIBW.Enabled.Equals(True) Then
				btnRadioCDIGray.Checked = True
				btnRadioCDIBW.Checked = False
			End If

			' Updating resolution options for scanning unit
			Dim strResolution As String
			strResolution = cmbResolution.Text
			If btnRadioSMCheckPaper.Checked = True Then
				cmbResolution.Items.Clear()
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100)
				If SetIndexResolutionCombobox(strResolution) <> True Then
					' If selected option is disabled, 300*300 is set
					cmbResolution.SelectedIndex = 0
				End If
			ElseIf btnRadioSMCard.Checked = True Then
				cmbResolution.Items.Clear()
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300)
				cmbResolution.Items.Add(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200)
				If SetIndexResolutionCombobox(strResolution) <> True Then
					' If selected option is disabled, 200*200 is set
					cmbResolution.SelectedIndex = 2
				End If
			End If

			'''/////////////
			'''/ Step 3 ////
			'''/////////////

			If btnRadioSMCard.Checked = True Then
				btnRadioMFE13B.Enabled = False
				btnRadioMFCMC7.Enabled = False
				btnCheckMIClearSpace.Enabled = False
				btnCheckMISaveFile.Enabled = False
			ElseIf btnRadioSMCheckPaper.Checked = True Then
				btnRadioMFE13B.Enabled = True
				btnRadioMFCMC7.Enabled = True
				btnCheckMIClearSpace.Enabled = True
				btnCheckMISaveFile.Enabled = True
			End If

			'''/////////////
			'''/ Step 4 ////
			'''/////////////

			If btnRadioSMCard.Checked = True Then
				btnRadioPTPhysical.Enabled = False
				btnRadioPTElectronic.Enabled = False
				btnRadioPMHighSpeed.Enabled = False
				btnRadioPMDataWaiting.Enabled = False
				btnCheckENPrintText.Enabled = False
				btnCheckENPrintImage.Enabled = False
				btnCheckENPrnDataReceiveCancel.Enabled = False
			ElseIf btnRadioSMCheckPaper.Checked = True Then
				btnRadioPTPhysical.Enabled = True
				btnRadioPTElectronic.Enabled = True
				btnRadioPMHighSpeed.Enabled = True
				btnRadioPMDataWaiting.Enabled = True
				btnCheckENPrintText.Enabled = True
				btnCheckENPrintImage.Enabled = True
				btnCheckENPrnDataReceiveCancel.Enabled = True
			End If

			If btnRadioPTPhysical.Enabled.Equals(True) AndAlso btnRadioPTPhysical.Checked = True Then
				btnRadioPMHighSpeed.Enabled = True
				btnRadioPMDataWaiting.Enabled = True
			Else
				btnRadioPMHighSpeed.Enabled = False
				btnRadioPMDataWaiting.Enabled = False
			End If

			If btnRadioPMHighSpeed.Enabled.Equals(True) AndAlso btnRadioPMHighSpeed.Checked = True Then
				btnCheckENPrnDataReceiveCancel.Enabled = True
			Else
				btnCheckENPrnDataReceiveCancel.Enabled = False
			End If

		End Sub

		'''/////////////
		'''/ Step 2 ////
		'''/////////////

		Private Sub btnOK_Click(sender As Object, e As EventArgs)
			GetControlData()
			Close()
		End Sub

		Private Sub btnCancel_Click(sender As Object, e As EventArgs)
			Close()
		End Sub

		Private Sub OnChangeRadioScanningMedia(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub OnChangeRadioImageChannel(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Function SetIndexResolutionCombobox(strResolution As String) As Boolean
			If strResolution IsNot Nothing Then
				If cmbResolution.Items.Contains(strResolution) = True Then
					cmbResolution.SelectedIndex = cmbResolution.Items.IndexOf(strResolution)
					Return True
				Else
					cmbResolution.SelectedIndex = 0
					Return False
				End If
			End If

			cmbResolution.SelectedIndex = 0
			Return False
		End Function

		Private Function GetValueResolutionCombobox() As Integer
			Dim strResolution As String
			strResolution = cmbResolution.Text

			If strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_600600) = True Then
				Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_600600
			End If
			If strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_300300) = True Then
				Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_300300
			End If
			If strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_240240) = True Then
				Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_240240
			End If
			If strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_200200) = True Then
				Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_200200
			End If
			If strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_120120) = True Then
				Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_120120
			End If
			If strResolution.Equals(ConstComStr.STR_CONFIGDLG_COMBO_RE_100100) = True Then
				Return ConstComVal.VAL_CONFIGDLG_COMBO_RE_100100
			End If

			Return -1
		End Function

		'''/////////////
		'''/ Step 3 ////
		'''/////////////

		' None.

		'''/////////////
		'''/ Step 4 ////
		'''/////////////
		Private Sub btnRadioPMHighSpeed_CheckedChanged(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnRadioPMDataWaiting_CheckedChanged(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnRadioPTPhysical_CheckedChanged(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub

		Private Sub btnRadioPTElectronic_CheckedChanged(sender As Object, e As EventArgs)
			UpdateControls()
		End Sub
	End Class
End Namespace
